checkRequire("Lua_CollectionWeaponBaseWindow");
Lua_CollectionBShareWeaponWindow = class("Lua_CollectionBShareWeaponWindow", Lua_CollectionWeaponBaseWindow);
function Lua_CollectionBShareWeaponWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_CollectionBShareWeaponWindow";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
end

function Lua_CollectionBShareWeaponWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.otherPlayerObj:SetActive(true);
	self.selfObj:SetActive(false);

	local otherPCardInfo = DataCenter.collectionBookData.otherPCardInfo;
	self.admireCount = otherPCardInfo and otherPCardInfo.like_num;
	self.admireCountTxt.text = self.admireCount;
	local otherPlayer = DataCenter.collectionBookData:getOtherPlayerInfo();
	self.playerNameTxt.text = otherPlayer and otherPlayer.name or nil;
	self.canAdmire = DataCenter.collectionBookData.otherCanAdmire or false;
end

function Lua_CollectionBShareWeaponWindow:showWin(param)
	self:superCall("showWin", param);
end


function Lua_CollectionBShareWeaponWindow:dispose()
	DataCenter.collectionBookData:clearOtherPlayerInfo();
	if self.pageCardList then
		for i = 1, #self.pageCardList do
			self.pageCardList[i]:dispose();
			self.pageCardList[i] = nil;
		end
		self.pageCardList = nil;
	end
	self:superCall("dispose");
end

function Lua_CollectionBShareWeaponWindow:onClickAdmireSp()
	if DataCenter.collectionBookData.residueAdmireCount <= 0 then
		OperateAlert.showLangValue(410005);
		return;
	end

	local otherPlayerInfo = DataCenter.collectionBookData:getOtherPlayerInfo();
	local playerId = otherPlayerInfo ~= nil and otherPlayerInfo.id or nil;
	if not self.canAdmire then
		OperateAlert.showLangValue(410006);
		return;
	end

	if DataCenter.roleData:isMyself(playerId) then
		OperateAlert.showLangValue(410007);
		return;
	end

	if playerId then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sAdmireOtherPlayer(playerId, otherPlayerInfo.server_flag);
		self.canAdmire = false;
		self.admireCountTxt.text = self.admireCount + 1;
	end
end

function Lua_CollectionBShareWeaponWindow:onClickOpenCardBook()
	self:hideShareObj();-- 隐藏shareObj

	Lua_WindowUtil.openWin("Lua_CollectionBShareBookWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_CollectionBShareWeaponWindow:updateCardCount()
	local otherPCardInfo = DataCenter.collectionBookData.otherPCardInfo or {};
	self.curCommonCount = otherPCardInfo.common_amount or 0;
	self.curFlashCount = otherPCardInfo.flash_amount or 0;
end

-- 创建封面卡牌
function Lua_CollectionBShareWeaponWindow:createPageCards()
	local limitCount = DataCenter.collectionBookUtil.CBMaxCount;
	local cardIds = DataCenter.collectionBookData.otherPageIds;
	if self.pageCardList == nil then
		self.pageCardList = {};
	end

	local item;
	for i = 1, limitCount do
		item = self.pageCardList[i];
		if item == nil then
			item = Lua_CollectionWeaponBaseItem.new(self.content);
			item:setSiblingIndex(self.logoSp.siblingIndex);
			item:setShareItem(true);
			self.pageCardList[i] = item;
		end
		self.pageCardList[i]:setData(cardIds[i], i);
	end
end