checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionBookActiveCardWindow = class("Lua_CollectionBookActiveCardWindow", Lua_Window);
function Lua_CollectionBookActiveCardWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_CollectionBookActiveCardWindow";
	self.skinName = "CollectionBookActiveCardWindow_skin";
	self.showBlackMask = true
	self.isClickClose = true;
end

function Lua_CollectionBookActiveCardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem.openTime = 0.1;
	self.flashItem.rotateNum = 1;
end

function Lua_CollectionBookActiveCardWindow:dispose()
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	self:superCall("dispose");
end

function Lua_CollectionBookActiveCardWindow:showWin(param)
	self:superCall("showWin", param);

	local cfg = Lua_CollectionBookConfigData.getConfig(param);
	if cfg == nil then
		return;
	end

	local flashId = cfg.flash_id;
	if flashId == nil then
		return;
	end
	-- 閃卡
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
	self.flashItem:setData(flashInfo);
	self:updateCardEffect();
end

-- 特效
function Lua_CollectionBookActiveCardWindow:updateCardEffect()
	local bShow = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.showData);
	if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.frontPageObj, "/effects/uiEffects/ui_scc_sk_0002", "ui_scc_sk_0002", 0, 0);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end