checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionBookCardDetailWindow = class("Lua_CollectionBookCardDetailWindow", Lua_Window);
function Lua_CollectionBookCardDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CollectionBookCardDetailWindow";
	self.skinName = "CollectionBookCardDetailWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;

	-- self.setImgPath = "/images/common/ui_common_window_016.png";
    -- self:addPreLoadRes(self.setImgPath, Lua_LoadFileType.IMG);
end

function Lua_CollectionBookCardDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.backBtn:setLocation(55, 54);
	self.shareObj:SetActive(false);

	-- 分享icon的背景
	self.shareBg.clickScale = false;
	self.shareBg.clickSound = nil;
	self.shareBg:addClickFuntion(self, self.onShareBgClick);

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setRectAnchor(1);
	self.flashItem:setLocation(0, -518);
	self.flashItem:setScale(0.9, 0.9);
	-- self.flashItem:setCallBack(self, self.onClickShowBackPage);
	self.flashItem.openTime = 0.1;
	self.flashItem.rotateNum = 1;
	self.flashItem.canRotate = true;

	self.centerList = Lua_CenterList.new(self.content, 490, 270, Lua_AxisDefine.Horizontal);
	self.centerList:setCellList(Lua_CollectionBookCardDetailItem, 168, 248);
	self.centerList.type = 2;
	self.centerList:setTransformData(-30, 8, 0.72, 0.8);
	self.centerList:setShowCount(3);
	self.centerList:setLocation(0, -378);
	self.centerList:setCallBack(self, self.cutCallBack);
	UIUtils.setObjSiblingIndex(self.shareObj, self.centerList.siblingIndex);

	self.shareSp:addClickFuntion(self, self.onClickShowShareIcon); -- 分享显示icon
	self.worldIcon:addClickFuntion(self, self.onClickShareWorldIcon); -- 世界分享icon
	self.areaIcon:addClickFuntion(self, self.onClickShareAreaIcon); -- 频道分享icon
	self.showBtnSp:addClickFuntion(self, self.onClickShowBtnSp); -- 多功能icon
	self.lastIcon:addClickFuntion(self, self.onClickLastHeroIcon); -- 点击上一英雄
	self.nextIcon:addClickFuntion(self, self.onClickNextHeroIcon); -- 点击下一英雄
	self.classicCardSp:addClickFuntion(self, self.onClickClassicCardSp); -- 点击经典卡

	self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.updateRewardState); -- 卡牌奖励更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_PUSHBOOK", self, self.updateBtnState); -- 卡牌放入卡册更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_ACTIVECARD", self, self.updateWindowInfo); -- 激活卡牌更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_CARD_REDPOINT", self, self.updateWindowInfo); -- 道具监听
end

function Lua_CollectionBookCardDetailWindow:showWin(param)
	self:superCall("showWin", param);

	self.cardId = param; 
	self:updateCurCardCfg();
	if self.cardCfg == nil then
		return;
	end

	self.bagId = self.cardCfg.hero_id;
	self.cBookVo = DataCenter.collectionBookData:getCollectionBookVoById(self.bagId);
	if self.cBookVo == nil then
		return;
	end

	self:checkClassicCard();
	self.curCommonCard = self.bClassic and self.cBookVo.common or self.cardId;
	self.cardIdTab = self.cBookVo.show_detail_ids;

	self:showCardList();
	self:updateWindowInfo(false);
end

function Lua_CollectionBookCardDetailWindow:updateCurCardCfg()
	self.cardCfg = Lua_CollectionBookConfigData.getConfig(self.cardId);
end

function Lua_CollectionBookCardDetailWindow:checkClassicCard()
	if self.cBookVo == nil then
		return;
	end
	self.bClassic = self.cBookVo.classic == self.cardId;
end

function Lua_CollectionBookCardDetailWindow:dispose()
	self.cardCfg = nil;
	self.cBookVo = nil;
	self.cardIdTab = nil;
	-- if self.cardItems ~= nil then
	-- 	for k, v in pairs(self.cardItems) do
	-- 		v:dispose();
	-- 		v = nil;
	-- 	end
	-- end
	if self.rewardRedPoint ~= nil then
		self.rewardRedPoint:dispose();
		self.rewardRedPoint = nil;
	end
	if self.btnRedPoint ~= nil then
		self.btnRedPoint:dispose();
		self.btnRedPoint = nil;
	end
	if self.effect ~= nil then
        self.effect:dispose();
        self.effect = nil;
    end
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.centerList ~= nil then
		self.centerList:dispose();
		self.centerList = nil;
	end
	if self.classicItem ~= nil then
		self.classicItem:dispose();
		self.classicItem = nil;
	end
	self:superCall("dispose");
end

function Lua_CollectionBookCardDetailWindow:onShareBgClick()
end

--分享
function Lua_CollectionBookCardDetailWindow:onClickShowShareIcon()
	local isShow = self.shareObj.activeSelf;
	self.shareObj:SetActive(not isShow);

	self.isOpenWorld = DataCenter.funcOpenData:isOpened(10228);
	self.worldIcon:setGray(not self.isOpenWorld);
	
	self.isOpenArea = DataCenter.funcOpenData:isOpened(10229);
	local isShow = DataCenter.roleData.league_id > 0 and self.isOpenArea;
	self.areaIcon:setGray(not isShow);
end

function Lua_CollectionBookCardDetailWindow:onClickShareWorldIcon()
	if not self.isOpenWorld then
		OperateAlert.showLangValue(410004);
	else
		self.shareObj:SetActive(false);
		local unlockTime = self.cBookVo:getCardTimeByCardId(self.cardId);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD, {cardId = self.cardId, active_time = unlockTime});
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionBookCardDetailWindow:onClickShareAreaIcon()
	if not self.isOpenArea then
		OperateAlert.showLangValue(410004);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(410058);
	else
		self.shareObj:SetActive(false);
		local unlockTime = self.cBookVo:getCardTimeByCardId(self.cardId);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD, {cardId = self.cardId, active_time = unlockTime});
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionBookCardDetailWindow:hideShareObj()
	self.shareObj:SetActive(false);
end

function Lua_CollectionBookCardDetailWindow:onClickReward()
	self:hideShareObj();-- 隐藏shareObj
	if self.cBookVo.receive_reward_redpoint then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sReceivedReward(self.bagId);
	else
		local reward = self.cBookVo.reward;
		if reward ~= nil and #reward > 0 then
			local tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]); 
			DataCenter.packUtil:showItemInfo(tvo);
		end
	end
end

-- 经典卡/神兵卡互换
function Lua_CollectionBookCardDetailWindow:onClickClassicCardSp()
	if self.centerList.isMoveing == true then
		return;
	end

	self:hideShareObj();-- 隐藏shareObj

	local cardId = self.bClassic and self.curCommonCard or self.cBookVo.classic;
	self.cardId = cardId;
	self:checkClassicCard();
	self:updateCurCardCfg();
	self:updateWindowInfo(false);

    if self.bClassic ~= true then
    	self:showClassicCard(false);
		self.centerList:setEnable(true);
	else
		self:showClassicCard(true);
		self.centerList:setEnable(false);
	end
end

-- 卡牌组
function Lua_CollectionBookCardDetailWindow:showCardList()
	if self.bClassic then
		self:showClassicCard(true);
		self.centerList:setEnable(false);
	end

	local index = self.cBookVo and self.cBookVo:getShowDetailIndexByCardId(self.curCommonCard) or 1;
	self.centerList:setArrayData(self.cardIdTab);
	self.centerList:moveToIndex(index, true);
	self.curIndex = index;
end

function Lua_CollectionBookCardDetailWindow:showClassicCard(bShow)
	if bShow then
		if self.classicItem == nil then
			local classicCardId = self.cBookVo and self.cBookVo.classic or nil;
			self.classicItem = Lua_CollectionBookCardDetailItem.new(self.content);
			self.classicItem:setLocation(0, -378);
			self.classicItem:setScale(0.8, 0.8, 1);
			UIUtils.setObjSiblingIndex(self.shareObj, self.classicItem.siblingIndex);
			self.classicItem:setData(classicCardId);
		end
		self.classicItem:setEnable(true);
	else
		if self.classicItem ~= nil then
			self.classicItem:setEnable(false);
		end
	end
end

--isActive,是否由于激活而进行更新
function Lua_CollectionBookCardDetailWindow:updateWindowInfo(isActive)
	if self.cardCfg == nil then
		print("no card");
		return;
	end

	if self.cBookVo == nil then
		return;
	end

	-- 閃卡
	local flashId = self.cardCfg.flash_id;
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
	self:setFlashCardPos(flashInfo); 
	self.flashItem:setData(flashInfo); 
	-- 解锁时间
	local unlockTimeStr;
	if self.cBookVo:checkActiveByCardId(self.cardId) then
		local time = self.cBookVo:getCardTimeByCardId(self.cardId);
		unlockTimeStr = LanUtil.formateStr(410035, Lua_TimeTransform.transSeconds25(time));
	end
	self.activeTimeTxt.text = unlockTimeStr;
	self.timeBg:setEnable(unlockTimeStr ~= nil);
	self.flashItem:setGray(unlockTimeStr == nil);

	-- 奖励
	self:updateRewardState();
	-- 特效
	self:updateCardEffect();	
	-- 经典卡或典藏卡
	self:showClassicSp();
	-- 多功能按钮
	self:updateBtnState();
	-- 卡牌组
	self:updateShowCardId(isActive)
end

function Lua_CollectionBookCardDetailWindow:setFlashCardPos(flashInfo)
	local itemPosY, timeTxtPosY, timeBgPosY = -518, -64, -64;
	local timeTxtPosX = 77;
	local timeBgWidget = 595;
	if self.bClassic then
		local widget, height = flashInfo:getDistance();
		height = height ~= 0 and height / 2 or 0;
		itemPosY, timeTxtPosY, timeBgPosY = itemPosY - height, timeTxtPosY - height * 2, timeBgPosY - height * 2;
		timeTxtPosX = timeTxtPosX + widget / 2;
		timeBgWidget = timeBgWidget - widget;
	end

	self.flashItem:setLocation(0, itemPosY);
	self.timeBg:setLocation(-3, timeBgPosY);
	self.timeBg:SetDimensions(timeBgWidget, 41);
	self.activeTimeTxt:setLocation(timeTxtPosX, timeTxtPosY);
end

-- 奖励状态更新
function Lua_CollectionBookCardDetailWindow:updateRewardState()
	if self.cBookVo == nil then
		return;
	end

	local hasReward = self.cBookVo.receive_reward_redpoint;
	local bCommonCard = self.cBookVo.common == self.cardId;
	local bShow = hasReward and bCommonCard;
	self:showReward(bShow);
	self:showRewardRedDot(bShow);
end

function Lua_CollectionBookCardDetailWindow:showReward(bShow)
	if bShow then
		if self.rewardIcon == nil then
			self.rewardIcon = Lua_ItemIcon.new(self.content);
			self.rewardIcon:setClick(self, self.onClickReward);
			self.rewardIcon:setRectAnchor(1);
			self.rewardIcon:setLocation(235, -879, 0);
			self.rewardIcon:setScale(0.6, 0.6);

			if self.cBookVo == nil then
				return;
			end
			local reward = self.cBookVo.reward;
			if reward ~= nil and #reward > 0 then
				local tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]);
				self.rewardIcon:setData(tvo);
			end
		end
		self.rewardIcon:setEnable(true);
	else
		if self.rewardIcon ~= nil then
			self.rewardIcon:setEnable(false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:showRewardRedDot(bShow)
	if bShow == true then
		if self.rewardRedPoint == nil then
			self.rewardRedPoint = Lua_RedPointIcon.new(self.content);
			self.rewardRedPoint:setRectAnchor(1);
			self.rewardRedPoint:setLocation(265, -849, 0);
			self.rewardRedPoint:createRedPointEff();
		end
		self.rewardRedPoint:updateRedPointShow(true);
	else
		if self.rewardRedPoint ~= nil then
			self.rewardRedPoint:updateRedPointShow(false);
		end
	end
end

-- 特效
function Lua_CollectionBookCardDetailWindow:updateCardEffect()
	local bShow = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.cardId);
	if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.frontPageObj, "/effects/uiEffects/ui_scc_sk_0001", "ui_scc_sk_0001", 21, -32);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end

-- 展示经典卡或典藏卡
function Lua_CollectionBookCardDetailWindow:showClassicSp()
	if self.cBookVo == nil then
		return;
	end

	local bShow = self.cBookVo.card_type ~= Lua_CollectionBookUtil.FRAME_CARD and self.cBookVo.card_type ~= Lua_CollectionBookUtil.CONTACT_CARD;
	local hasCard = self.cBookVo:checkCardComplete(self.cBookVo.classic) > 0;
	if bShow and hasCard ~= true then
		bShow = false;
	end

	if bShow then
		local spriteStr = self.bClassic and "xui_hb_button_13" or "xui_hb_button_12";
		self.classicCardSp:setAltas("collect_book_atlas", spriteStr);
		self.classicCardSp:setEnable(true);
		self.shareSp:setLocation(174.7, 52);
		self.shareBg:setScale(-1, -1, 1);
	else
		self.classicCardSp:setEnable(false);
		self.shareSp:setLocation(293, 52);
		self.shareBg:setScale(1, -1, 1);
	end

	self.lastIcon:setEnable(not self.bClassic);
	self.nextIcon:setEnable(not self.bClassic);

	local bActive = self.cBookVo:checkActiveByCardId(self.cardId);
	self.shareSp:setEnable(bActive);
end

-- 更新按钮的状态
function Lua_CollectionBookCardDetailWindow:updateBtnState()
	local bCompleted = self.cBookVo:checkCardComplete(self.cardId) > 0;
	if not bCompleted then
		print("this card is not complated ");
	end

	self:showBtnRedDot(false);

	self.showBtnSp:setEnable(not self.bClassic);
	self.showBtnTxt:setEnable(not self.bClassic);
	if self.bClassic then
		return;
	end

	local pushId;
	local bActive = self.cBookVo:checkActiveByCardId(self.cardId);
	if self.cBookVo:checkActiveByCardId(self.cBookVo.pushId) then
		pushId = self.cBookVo.pushId;
	end

	if pushId == self.cardId then
		self.showBtnTxt:setLangValue(410036);--"展示中";
		self.btnActionIndex = 1;
	elseif bActive then
		self.showBtnTxt:setLangValue(410037);--"放入卡册";
		self.btnActionIndex = 2;
	else
		-- 【神兵卡-英雄系统收集】通过英雄系统收集
		local bCollectedFromHeroSystem = self.cardCfg.fromHeroSystem;
		if bCollectedFromHeroSystem then
			self.showBtnTxt:setLangValue(410038);--"去获取";
			self.btnActionIndex = 3;
		else
			-- 【神兵卡-其他收集方式】	or 【英雄闪卡】
			local bOnlyCard = self.cardCfg.checkOnlyCard;-- 仅有卡
			local bHeroCard = self.cardCfg.checkHeroCard;-- 英雄闪卡
			if bOnlyCard or bHeroCard then
				local canActive = self.cBookVo:canActiveByCardId(self.cardId);
				if canActive then
					self.showBtnTxt:setLangValue(410039);--"激活";
					self.btnActionIndex = 4;					
					self:showBtnRedDot(true);
				else
					self.showBtnTxt:setLangValue(410038);--"去获取";
					self.btnActionIndex = 5;
				end
			else
				--【皮肤闪卡】
				local bSkinCard = self.cardCfg.checkClothCard; -- 皮肤闪卡
				if bSkinCard then
					self.showBtnTxt:setLangValue(410038);--"去获取";
					self.btnActionIndex = 6;
				end
			end
		end
	end
	self:showCardList();
end

function Lua_CollectionBookCardDetailWindow:showBtnRedDot(bShow)
	if bShow == true then
		if self.btnRedPoint == nil then
			self.btnRedPoint = Lua_RedPointIcon.new(self.content);
			self.btnRedPoint:setRectAnchor(7);
			self.btnRedPoint:setLocation(94, 142, 0);
			self.btnRedPoint:createRedPointEff();
		end
		self.btnRedPoint:updateRedPointShow(true);
	else
		if self.btnRedPoint ~= nil then
			self.btnRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookCardDetailWindow:updateShowCardId(isActive)
	if self.bClassic then
		self.lastCardId = nil;
		self.nextCardId = nil;
	else
		local index = self.cBookVo:getShowDetailIndexByCardId(self.cardId);
		index = index or 0;
		local lastIndex = index - 1;
		local nextIndex = index + 1;
		self.lastCardId = self.cardIdTab[lastIndex];
		self.nextCardId = self.cardIdTab[nextIndex];
		if isActive == nil then
			isActive = true;
		end
		if isActive then
			self.centerList:setArrayData(self.cardIdTab, false);
		end
	end
end

-- 点击上一英雄
function Lua_CollectionBookCardDetailWindow:onClickLastHeroIcon()
	self:hideShareObj();-- 隐藏shareObj
	if self.lastCardId == nil then
		OperateAlert.showLangValue(410041);
	else
		self.centerList:moveToIndex(self.curIndex - 1);
	end
end

-- 点击下一英雄
function Lua_CollectionBookCardDetailWindow:onClickNextHeroIcon()
	self:hideShareObj();-- 隐藏shareObj
	-- 更改self.ordinaryCardId
	if self.nextCardId == nil then
		OperateAlert.showLangValue(410042);
	else
		self.centerList:moveToIndex(self.curIndex + 1);
	end
end

--滑动切换回调，val：true上一个，false下一个
function Lua_CollectionBookCardDetailWindow:cutCallBack()
	self:hideShareObj();-- 隐藏shareObj
	local index = self.centerList.curIndex;
	if index == self.curIndex then
		return;
	end
	if index < self.curIndex then
		if self.lastCardId == nil then
			return;
		end
		self.cardId = self.lastCardId;
		self.curCommonCard = self.cardId;
	elseif index > self.curIndex then
		if self.nextCardId == nil then
			return;
		end
		self.cardId = self.nextCardId;
		self.curCommonCard = self.cardId;	
	end
	self.curIndex = index;
	self:updateCurCardCfg();
	self:updateWindowInfo(false);
end

function Lua_CollectionBookCardDetailWindow:onClickShowBtnSp()
	self:hideShareObj();-- 隐藏shareObj
	-- 展示中
	if self.btnActionIndex == 1 then 
		OperateAlert.showLangValue(410040);
	-- 放入卡册
	elseif self.btnActionIndex == 2 then 
		self:updatePushIdInBag(self.cardId);
	-- 【神兵卡-英雄系统收集】：去获取 -->点击跳转英雄系统对应英雄图鉴页
	elseif self.btnActionIndex == 3 then 
		local collectionPath = DataCenter.collectionBookUtil:getCollectionHeroPathId();
		DataCenter.packUtil:openPathWindow(collectionPath, false);
	-- 【神兵卡-其他收集方式】 or 【英雄闪卡】:激活 -->服务端消息号激活
	elseif self.btnActionIndex == 4 then 
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sActiveCardInfo(self.cardId);
	-- 【神兵卡-其他收集方式】 or 【英雄闪卡】:去获取 -->点击弹出获取渠道tips
	elseif self.btnActionIndex == 5 then 
		local exchangeItems = self.cardCfg.change_item;
		if exchangeItems then
			local itemId = exchangeItems[1][1];
			DataCenter.packUtil:openPathWindow(itemId, false);
		else
			local flashCardCollectiPath = DataCenter.collectionBookUtil:getCollectionFlashPathId();
			DataCenter.packUtil:openPathWindow(flashCardCollectiPath, false);
		end
	-- 【皮肤闪卡】:去获取 -->点击跳转至英雄系统对应皮肤页面
	elseif self.btnActionIndex == 6 then 
		-- DataCenter.heroAtlasData:onOpenAtlasWindow(self.heroId,4, nil, nil);
		local collectionPath = DataCenter.collectionBookUtil:getCollectionSkinPathId();
		DataCenter.packUtil:openPathWindow(collectionPath, false);
	elseif self.btnActionIndex == 7 then
		OperateAlert.showLangValue(410033);
	end
end

-- 封面卡牌更新
function Lua_CollectionBookCardDetailWindow:updatePushIdInBag(cardId)
	local pushId = self.cBookVo.pushId
	local bChange = pushId ~= nil and pushId ~= cardId;
	if bChange then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sPlaceCardInBookInfo(cardId);

		local dic = DataCenter.collectionBookData.ownerPageIdDic or {};
		local ids = DataCenter.collectionBookData.ownerPageIds or {};
		local index = dic[pushId];
		if index then
			local id;
			local list = {0, 0, 0}; -- 与服务端数据分割开
			for i = 1, 3 do
				id = ids[i];
				if index == i then
					if id == pushId then -- 进一步校验
						list[i] = cardId;
					end
				else
					list[i] = id;
				end
			end
			Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sSaveCBPageInfo(list);
		end
	end
end






























































































Lua_CollectionBookCardDetailItem = class("Lua_CollectionBookCardDetailItem", Lua_CenterCell);
function Lua_CollectionBookCardDetailItem:ctor(p, index)
	self:superCall("ctor", p, "CollectionBookCardDetailItem_skin");
end

function Lua_CollectionBookCardDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showSp:setEnable(false);
	self.blackMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 0, 188, 245);
	self.blackMask.alpha = 0.7;

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.onPackUpdate); -- 背包道具增加
    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onPackUpdate); -- 货币增加
end

function Lua_CollectionBookCardDetailItem:setData(data)
	self.data = data;
	if self.data == nil then
		self.excharge_item = nil;
		return;
	end

	self:updateItem();
end

function Lua_CollectionBookCardDetailItem:updateItem()
	self.excharge_item = nil;
	local cardCfg = Lua_CollectionBookConfigData.getConfig(self.data);
	if cardCfg == nil then
		return;
	end

	local bagId = cardCfg.hero_id;
	local cBookVo = DataCenter.collectionBookData:getCollectionBookVoById(bagId);
	if cBookVo == nil then
		return;
	end

	local bClassic = cBookVo.classic == self.data;
	if bClassic then
		self.blackMask:setEnable(false);
		self.cardNameTxt:setLocation(3, -103);
	else
		local val = self:checkInBound(0, 0);
		self.blackMask:setEnable(not val);
		self.cardNameTxt:setLocation(3, -226);
	end

	local bActive = cBookVo:checkActiveByCardId(self.data);
	local flashId = cardCfg.flash_id;
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId); 
	self.cardIcon:setUrl(flashInfo.flash_path_2);
	self.cardIcon:setGray(not bActive);
	self.cardNameTxt.text = flashInfo.flash_card_name;

	local str;
	local exchangeItem = cardCfg.change_item;
	if exchangeItem and not bActive then
		self.excharge_item = exchangeItem;
		local costId = tonumber(exchangeItem[1][1]);
		local curCount = DataCenter.packData:getItemCountById(costId);
		local item = Lua_ToolVo.createToolVo(costId);
		str = LanUtil.formateStr(410051, curCount, exchangeItem[1][2]);
		self.costSp:setAltas(item.atlas, item.sprite);
		self.costSp:setEnable(true);
		self.costBg:setEnable(true);
	else
		self.costSp:setEnable(false);
		self.costBg:setEnable(false);
	end
	self.costTxt.text = str;

	local canActive = cBookVo:canActiveByCardId(cardId);
	self:showRedDot(canActive);

	local bShow = cBookVo.pushId == self.data;
	self.showSp:setEnable(bShow);

	bShow = cardCfg.checkHeroCard or cardCfg.checkClothCard;
	local spriteStr = bShow and "xui_scc_widget_31" or "xui_hb_widget_15";
	self.nameBg:setAltas("collect_book_atlas_2", spriteStr);
end

function Lua_CollectionBookCardDetailItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(81, 117, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionBookCardDetailItem:onPackUpdate(dic)
	if self.excharge_item == nil or #self.excharge_item <= 0 or dic == nil then
		return;
	end

	local costId;
	local bChange;
	for i = 1, #self.excharge_item do
		costId = tonumber(self.excharge_item[i][1]);
		if dic[costId] then
			bChange = true;
			break;
		end
	end

	if not bChange then
		return;
	end

	-- self:updateItem();
	Lua_MsgUtil.callFunc("UPDATE_CBCARDDETAIL_CARD_REDPOINT", false);
end

function Lua_CollectionBookCardDetailItem:dispose()	
	if self.blackMask ~= nil then
		self.blackMask:dispose();
		self.blackMask = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end