Lua_CollectionBookTabItem = class("Lua_CollectionBookTabItem", Lua_ListCell);
function Lua_CollectionBookTabItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionBookTabItem:buildShowItem()
	self:superCall("buildShowItem");

	self.tabIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 0, 108, 118);
	self.splitSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_line_001", 61, 0, 2, 112);
end

function Lua_CollectionBookTabItem:dispose()
	if self.tabIcon ~= nil then
		self.tabIcon:dispose();
		self.tabIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.bSelectedBg then
		self.bSelectedBg:dispose();
		self.bSelectedBg = nil;
	end
	self:superCall("dispose");
end

function Lua_CollectionBookTabItem:setData(data)
	if data.tabAtlas == nil or data.tabSprite == nil then
		self.tabIcon:setEnable(false);
	else
		self.tabIcon:setEnable(true);
		self.tabIcon:setAltas(data.tabAtlas, data.tabSprite);
	end
	self.tabIcon:resetSize();

	self.openWin = data.openWin;
	self.tabId = data.tabId;
	self:showRedDot(data.redPointId);
	self:showSelected(data.bSelected);
end

function Lua_CollectionBookTabItem:onPressClick()
	Lua_MsgUtil.callFunc("CBWEAPON_HIDESHAREOBJ");
	if self.openWin ~= nil then
		Lua_WindowUtil.openWin(self.openWin, Lua_WinParam.ACTION_OPEN, self.tabId);
	end
end

function Lua_CollectionBookTabItem:showRedDot(redPointId)
	if redPointId ~= nil and self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content, redPointId);
		self.redPoint:setLocation(41, 42, 0);
	end
end

function Lua_CollectionBookTabItem:showSelected(bSelected)
	if bSelected then
		if self.bSelectedBg == nil then
			self.bSelectedBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_001_b", 0, 0, 118, 108);
			self.bSelectedBg.siblingIndex = 0;
		end
		self.bSelectedBg:setEnable(true);
	else
		if self.bSelectedBg then
			self.bSelectedBg:setEnable(false);
		end
	end
end