checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionWeaponBaseWindow = class("Lua_CollectionWeaponBaseWindow", Lua_Window);
function Lua_CollectionWeaponBaseWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CollectionWeaponBaseWindow";
	self.skinName = "CollectionWeaponBaseWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_1.jpg";

    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_CollectionWeaponBaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.otherPlayerObj:SetActive(false);
	self.selfObj:SetActive(false);
	self.shareObj:SetActive(false);
	self.activityNameTxt:setLangValue(410002);
	self.playerNameTxt.text = nil;
	self.admireCountTxt.text = nil;

	self.bottomSp.mouseEnable = true;

	self.totalFlashCardCount = DataCenter.collectionBookUtil.flashTCount;
	self.totalOrdinaryCardCount = DataCenter.collectionBookUtil.commonTCount;
	self:updateWinDisplay();
	
	-- 分享icon的背景
	self.shareBg.clickScale = false;
	self.shareBg.clickSound = nil;
	self.shareBg:addClickFuntion(self, self.onShareBgClick);

	self.tipsIcon:addClickFuntion(self, self.onClickTipsIcon); -- 提示Icon
	self.shareIcon:addClickFuntion(self, self.onClickShowShareIcon); -- 分享显示icon
	self.worldIcon:addClickFuntion(self, self.onClickShareWorldIcon); -- 世界分享icon
	self.areaIcon:addClickFuntion(self, self.onClickShareAreaIcon); -- 频道分享icon
	self.winBg:addClickFuntion(self, self.onClickOpenCardBook); -- 打开卡册
	self.admireSp:addClickFuntion(self, self.onClickAdmireSp); -- 点赞icon
end

function Lua_CollectionWeaponBaseWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_CollectionWeaponBaseWindow:dispose()
	self:endTimer();
	self:superCall("dispose");
end

function Lua_CollectionWeaponBaseWindow:updateWinDisplay()
	self:updateCardCount();-- 卡牌数量更新  
	self:createRedPoint()
	self:startTimer();
	self:createPageCards();
end

function Lua_CollectionWeaponBaseWindow:onShareBgClick()
end

function Lua_CollectionWeaponBaseWindow:onClickTipsIcon()
	self:hideShareObj();-- 隐藏shareObj
	local tipsData = { des = LanUtil.getValue(410003), posX = 174, posY = -241 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

--分享
function Lua_CollectionWeaponBaseWindow:onClickShowShareIcon()
	local isShow = self.shareObj.activeSelf;
	self.shareObj:SetActive(not isShow);

	self.isOpenWorld = DataCenter.funcOpenData:isOpened(10228);
	self.worldIcon:setGray(not self.isOpenWorld);

	self.isOpenArea = DataCenter.funcOpenData:isOpened(10229);
	local isShow = DataCenter.roleData.league_id > 0 and self.isOpenArea;
	self.areaIcon:setGray(not isShow);
end

function Lua_CollectionWeaponBaseWindow:onClickShareWorldIcon()
	if not self.isOpenWorld then
		OperateAlert.showLangValue(410004);
	else
		self:hideShareObj();-- 隐藏shareObj
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_BOOK, true);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionWeaponBaseWindow:onClickShareAreaIcon()
	if not self.isOpenArea then
		OperateAlert.showLangValue(410004);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(410058);
	else
		self:hideShareObj();-- 隐藏shareObj
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_BOOK, true);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_CollectionWeaponBaseWindow:hideShareObj()
	self.shareObj:SetActive(false);
end

function Lua_CollectionWeaponBaseWindow:onClickOpenCardBook()
end

function Lua_CollectionWeaponBaseWindow:onClickAdmireSp()
end

function Lua_CollectionWeaponBaseWindow:updateCardCount()
	self.curCommonCount = 0;
	self.curFlashCount = 0;
end

-- 红点
function Lua_CollectionWeaponBaseWindow:createRedPoint()
end

-- 每2秒切换显示文本
function Lua_CollectionWeaponBaseWindow:startTimer()
	if self.loopSwitch ~= true then
		self:addTimer("CBWIN_LOOPSWITCH_TXT", 2, self, self.showCollectCountTxt);
		self.loopSwitch = true;
		self:showCollectCountTxt();
	end
end

function Lua_CollectionWeaponBaseWindow:endTimer()
	if self.loopSwitch == true then
		self.loopSwitch = false;
		self:removeTimer(self, self.showCollectCountTxt);
	end
end

function Lua_CollectionWeaponBaseWindow:showCollectCountTxt()
	local str;
	local curCount;
	local totalCount;
	self.switchIndex = self.switchIndex == nil and 0 or (self.switchIndex + 1) % 2;
	if self.switchIndex == 0 then
		str = LanUtil.getValue(410008);
		curCount = self.curCommonCount;
		totalCount = self.totalOrdinaryCardCount;
	else
		str = LanUtil.getValue(410009);
		curCount = self.curFlashCount;
		totalCount = self.totalFlashCardCount;
	end
	self.collectCountTxt.text = LanUtil.formateStr(410010, str, curCount, totalCount);
end

-- 创建封面卡牌
function Lua_CollectionWeaponBaseWindow:createPageCards()
end
































































--收藏册封面卡牌
Lua_CollectionWeaponBaseItem = class("Lua_CollectionWeaponBaseItem", Lua_DisplayObject);
function Lua_CollectionWeaponBaseItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionWeaponBaseItem:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem.canRotate = false; -- 是否可旋转
	self.flashItem:setSiblingIndex(0);
	self.flashItem:setCallBack(self, self.onPressClick);
end

function Lua_CollectionWeaponBaseItem:updateDisplayByIndex(index, bNewCard)
	local scale, sibling;
	if index == 1 then
		sibling = 13;
		scale = bNewCard and 0.48 or 0.64;
		self:setLocation(-160, -119);
	elseif index == 2 then
		sibling = 15;
		scale = bNewCard and 0.28 or 0.38;
		self:setLocation(145, 47);
	elseif index == 3 then
		sibling = 17;
		scale = bNewCard and 0.28 or 0.38;
		self:setLocation(185, -260);
	end
	self.flashItem:setScale(scale, scale);
end

function Lua_CollectionWeaponBaseItem:setData(data, index)
	self.data = data;
	if data == nil then
		return;
	end

	local cfg = Lua_CollectionBookConfigData.getConfig(self.data);
	if cfg == nil then
		self:setEnable(false);
		return;
	end
	
	local bagId = cfg.hero_id;
	local vo = DataCenter.collectionBookData:getCollectionBookVoById(bagId);
	if vo == nil then
		self:setEnable(false);
		return;
	end
	if self.bShare and vo:checkOtherActiveByCardId(self.data) ~= true then
		self:setEnable(false);
		return;
	elseif self.bShare ~= true and vo:checkActiveByCardId(self.data) ~= true then
		self:setEnable(false);
		return;
	end

	self:setEnable(true);
	local flashId = cfg.flash_id;
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
	self.flashItem:setData(flashInfo);
	self:updateDisplayByIndex(index, flashInfo.showNewCard);

	local bShowEffect = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);
	self:showEffect(bShowEffect);
end

function Lua_CollectionWeaponBaseItem:showEffect(bShow)
    if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.content, "/effects/uiEffects/ui_scc_sk_0002", "ui_scc_sk_0002", 0, 0);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end

function Lua_CollectionWeaponBaseItem:setShareItem(bShare)
	self.bShare = bShare;
end

function Lua_CollectionWeaponBaseItem:onPressClick()
	if self.data == nil then
		return;
	end
	
	if self.bShare then
		Lua_WindowUtil.openWin("Lua_CollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data));
	else
		Lua_WindowUtil.openWin("Lua_CollectionBookCardDetailWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data));
	end
end

function Lua_CollectionWeaponBaseItem:dispose()
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	self:superCall("dispose");
end