checkRequire("Lua_CollectionWeaponBaseWindow");
checkRequire("Lua_CollectionBookTabItem");
checkRequire("Lua_CommonFlashCardItem");
Lua_CollectionWeaponWindow = class("Lua_CollectionWeaponWindow", Lua_CollectionWeaponBaseWindow);
function Lua_CollectionWeaponWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectionWeaponWindow";
end

function Lua_CollectionWeaponWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.otherPlayerObj:SetActive(false);
	self.selfObj:SetActive(true);

	self:addLuaEvent("UPDATE_CBWEAPON_CARDCOUNT", self, self.updateCardCount); -- 卡牌数量更新
	self:addLuaEvent("UPDATE_CBWEAPON_CARDINFO", self, self.updateCardInfo); -- 封面卡牌更新
	self:addLuaEvent("CBWEAPON_HIDESHAREOBJ", self, self.hideShareObj); -- 隐藏shareObj
end

function Lua_CollectionWeaponWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_CollectionWeaponWindow:dispose()
	if self.redPoint then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.pageCardList then
		for i = 1, #self.pageCardList do
			self.pageCardList[i]:dispose();
			self.pageCardList[i] = nil;
		end
		self.pageCardList = nil;
	end
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabList ~= nil then
		self.tabList:dispose();
		self.tabList = nil;
	end

	self:superCall("dispose");
end

function Lua_CollectionWeaponWindow:onClickOpenCardBook()
	self:hideShareObj();-- 隐藏shareObj

	Lua_WindowUtil.openWin("Lua_CollectionBookDetailWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_CollectionWeaponWindow:updateWinDisplay()
	self:superCall("updateWinDisplay");
	self:createBottomTabList();
end

function Lua_CollectionWeaponWindow:updateCardCount()
	self.curCommonCount = DataCenter.collectionBookData.curComCount;
	self.curFlashCount = DataCenter.collectionBookData.curFlaCount;
end

-- 红点
function Lua_CollectionWeaponWindow:createRedPoint()
	if self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.CollectionBook_MainPage);
		self.redPoint:setLocation(20, 280);
	end
end

-- 创建封面卡牌
function Lua_CollectionWeaponWindow:createPageCards()
	self:updateCardInfo();
end

-- 设置封面卡牌
function Lua_CollectionWeaponWindow:updateCardInfo()
	local limitCount = DataCenter.collectionBookUtil.CBMaxCount;
	local cardIds = DataCenter.collectionBookData.ownerPageIds;
	if self.pageCardList == nil then
		self.pageCardList = {};
	end

	local item;
	for i = 1, limitCount do
		item = self.pageCardList[i];
		if item == nil then
			item = Lua_CollectionWeaponBaseItem.new(self.content);
			item:setSiblingIndex(self.logoSp.siblingIndex);
			item:setShareItem(false);
			self.pageCardList[i] = item;
		end
		self.pageCardList[i]:setData(cardIds[i], i);
	end
end

-- 创建底部页签buttonList
function Lua_CollectionWeaponWindow:createBottomTabList()
	if not self.isShareWindow then 
	    -- dragList数据
	    self.tabInfo = Array();
	    self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_3_n", openWin = "Lua_CollectionBookEditWindow"});
	    self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_1_n", openWin = "Lua_CollectionBookDetailWindow", tabId = 2, redPointId = Lua_RedPointList.CollectionBook_Rank});
		self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_2_n", openWin = "Lua_CollectionBookDetailWindow", tabId = 3});  

	    --Lua_DragList
	    local count = self.tabInfo:getSize();
	    local width = count > 4 and 520 or count * 112;
	    self.tabList = Lua_DragList.new(self.content, width, 118, Lua_AxisDefine.Horizontal);
		self.tabList:setLocation(-width / 2, 52, 0);
		self.tabList:setRectAnchor(8);
		self.tabList.pivot = -1;
		self.tabList:setListCell(Lua_CollectionBookTabItem, 112, 118, 1);
		self.tabList:setArrayData(self.tabInfo);
	end
end
