checkRequire("Lua_NewCollectionWeaponBaseWindow");
Lua_NewCollectionBShareWeaponWindow = class("Lua_NewCollectionBShareWeaponWindow", Lua_NewCollectionWeaponBaseWindow);
function Lua_NewCollectionBShareWeaponWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_NewCollectionBShareWeaponWindow";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
end

function Lua_NewCollectionBShareWeaponWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.otherPlayerObj:SetActive(true);
	self.selfObj:SetActive(false);
	self.editSp:setEnable(false);

	local otherPCardInfo = DataCenter.collectionBookData.otherPCardInfo;
	self.admireCount = otherPCardInfo and otherPCardInfo.like_num;
	self.admireCountTxt.text = self.admireCount;
	local otherPlayer = DataCenter.collectionBookData:getOtherPlayerInfo();
	self.playerNameTxt.text = otherPlayer and otherPlayer.name or nil;
	self.canAdmire = DataCenter.collectionBookData.otherCanAdmire or false;
end

function Lua_NewCollectionBShareWeaponWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_NewCollectionBShareWeaponWindow:dispose()
	DataCenter.collectionBookData:clearOtherPlayerInfo();
	if self.pageCardList then
		for i = 1, #self.pageCardList do
			self.pageCardList[i]:dispose();
			self.pageCardList[i] = nil;
		end
		self.pageCardList = nil;
	end
	self:superCall("dispose");
end

function Lua_NewCollectionBShareWeaponWindow:onClickAdmireSp()
	if DataCenter.collectionBookData.residueAdmireCount <= 0 then
		OperateAlert.showLangValue(410005);
		return;
	end

	local otherPlayerInfo = DataCenter.collectionBookData:getOtherPlayerInfo();
	local playerId = otherPlayerInfo ~= nil and otherPlayerInfo.id or nil;
	if not self.canAdmire then
		OperateAlert.showLangValue(410006);
		return;
	end

	if DataCenter.roleData:isMyself(playerId) then
		OperateAlert.showLangValue(410007);
		return;
	end

	if playerId then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sAdmireOtherPlayer(playerId, otherPlayerInfo.server_flag);
		self.canAdmire = false;
		self.admireCountTxt.text = self.admireCount + 1;
	end
end

function Lua_NewCollectionBShareWeaponWindow:onClickOpenCardBook()
	self:hideShareObj();-- 隐藏shareObj

	Lua_WindowUtil.openWin("Lua_NewCollectionBShareBookWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_NewCollectionBShareWeaponWindow:updateCardCount()
	local otherPCardInfo = DataCenter.collectionBookData.otherPCardInfo or {};
	self.curCommonCount = otherPCardInfo.common_amount or 0;
	self.curFlashCount = otherPCardInfo.flash_amount or 0;
end

function Lua_NewCollectionBShareWeaponWindow:updatePageImg()
	local url;
	local cardIds = DataCenter.collectionBookData.otherPageIds;
	local cardId = cardIds and cardIds[1];
	if cardId and cardId > 1 then
		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		if getConfig("collection_bag", bagId) and DataCenter.collectionBookUtil:bShieldCardBag(bagId) ~= true then
			local cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
			if cardCfg and cardCfg.page_img then
				url = cardCfg.page_img;
				self.cardNameTxt.text = cardCfg.card_Name;

				local flashId = cardCfg.flash_id;
				local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
				self.cardPageCampSp:setAltas(flashInfo.frontAtlas, flashInfo.frontSprite);
			end
		end
	end

	self.pageImg:setUrl(url);
	self.pageImg:setEnable(url ~= nil);
	self.cardTxtBg:setEnable(url ~= nil);
	self.cardNameTxt:setEnable(url ~= nil);
	self.cardPageCampSp:setEnable(url ~= nil);
end