checkRequire("Lua_CommonFlashCardItem");
Lua_NewCollectionBookCardDetailWindow = class("Lua_NewCollectionBookCardDetailWindow", Lua_Window);
function Lua_NewCollectionBookCardDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_NewCollectionBookCardDetailWindow";
	self.skinName = "NewCollectionBookCardDetailWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.isClickClose = true;

	-- self.setImgPath = "/images/common/ui_common_window_016.png";
    -- self:addPreLoadRes(self.setImgPath, Lua_LoadFileType.IMG);
end

function Lua_NewCollectionBookCardDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.timeBg:setEnable(false);
	self.activeTimeTxt:setEnable(false);
	self.shareSp:setEnable(false);
	self.noneCollectBg:setEnable(false);
	self.noneCollectTxt:setEnable(false);
	self.classicCardSp:setEnable(false);
	self.showBtnSp:setEnable(false);
	self.showBtnTxt:setEnable(false);
	self.costSp:setEnable(false);
	self.costTxt:setEnable(false);

	self.shareObj:SetActive(false);
	self.flashPropObj:SetActive(false);

	-- 分享icon的背景
	self.shareBg.clickScale = false;
	self.shareBg.clickSound = nil;
	self.shareBg:addClickFuntion(self, self.onShareBgClick);

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setLocation(0, 26);
	self.flashItem:setScale(0.9, 0.9);
	self.flashItem:setSiblingIndex(0);
	self.flashItem.openTime = 0.1;
	self.flashItem.rotateNum = 1;
	self.flashItem.canRotate = true;

	self.shareSp:addClickFuntion(self, self.onClickShowShareIcon); -- 分享显示icon
	self.worldIcon:addClickFuntion(self, self.onClickShareWorldIcon); -- 世界分享icon
	self.areaIcon:addClickFuntion(self, self.onClickShareAreaIcon); -- 频道分享icon
	self.showBtnSp:addClickFuntion(self, self.onClickShowBtnSp); -- 多功能icon
	self.classicCardSp:addClickFuntion(self, self.onClickClassicCardSp); -- 点击经典卡

	self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.showReward); -- 卡牌奖励更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_ACTIVECARD", self, self.updateCardInfo); -- 激活卡牌更新

	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.onPackUpdate); -- 背包道具增加
    self:addLuaEvent("MONEY_UPDATE", self, self.onPackUpdate); -- 货币增加
end

function Lua_NewCollectionBookCardDetailWindow:showWin(param)
	self:superCall("showWin", param);

	self.bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(param);
	self.bookVo = DataCenter.collectionBookData:getCollectionBookVoById(self.bagId); 
	if self.bookVo == nil then
		return;
	end

	self.bClassic = self.bookVo.classic == param;
	if self.bClassic then
		self.comCardId = self.bookVo.common;
		self.classicId = param;
	else
		self.comCardId = param;
		self.classicId = self.bookVo.classic;
	end

	self.curCardId = param;

	self:checkViewFlashCardProp();
	self:updateCardInfo();
end

function Lua_NewCollectionBookCardDetailWindow:dispose()
	self.bookVo = nil;
	self.cardCfg = nil;
	if self.rewardRedPoint ~= nil then
		self.rewardRedPoint:dispose();
		self.rewardRedPoint = nil;
	end
	if self.btnRedPoint ~= nil then
		self.btnRedPoint:dispose();
		self.btnRedPoint = nil;
	end
	if self.effect ~= nil then
        self.effect:dispose();
        self.effect = nil;
    end
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end

	self:superCall("dispose");
end

function Lua_NewCollectionBookCardDetailWindow:checkViewFlashCardProp()
	local bCheck = DataCenter.collectionBookData:checkFlashCardProp(self.curCardId);
	if bCheck then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sFlashCardDetailProp(self.curCardId); 
	end
end

function Lua_NewCollectionBookCardDetailWindow:updateCardInfo()
	self.costSp:setEnable(false);
	self.costTxt:setEnable(false);
	self:showBtnRedDot(false);

	self.cardCfg = Lua_CollectionBookConfigData.getConfig(self.curCardId);
	local flashId = self.cardCfg.flash_id;
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
	self:setFlashCardPos(); 
	self.flashItem:setData(flashInfo); 

	self.bActive = self.bookVo:checkActiveByCardId(self.curCardId);
	self.flashItem:setGray(self.bActive ~= true);
	self.flashItem:showNoCollectCardTxt(self.bActive ~= true);
	self.timeBg:setEnable(self.bActive);

	local activeTime = self.bookVo:getCardTimeByCardId(self.curCardId) or 0;
	if activeTime > 1 then
		self.activeTimeTxt.text = LanUtil.formateStr(410072, Lua_TimeTransform.transSeconds25(activeTime));
	else
		if self.bookVo:canActiveByCardId(self.curCardId) then
			self.showBtnTxt:setLangValue(410073);
		else
			self.showBtnTxt:setLangValue(410074);
		end

		local str;
		local change_item = self.cardCfg.change_item;
		if change_item and #change_item > 0 then
			local costId = tonumber(change_item[1][1]);
			local costValue = tonumber(change_item[1][2]);
			local curCount = DataCenter.packData:getItemCountById(costId);
			local item = Lua_ToolVo.createToolVo(costId);
			self.costSp:setAltas(item.atlas, item.sprite);
			if curCount >= costValue then
				str = LanUtil.formateStr(410075, curCount, costValue);
				self:showBtnRedDot(true);
			else
				str = LanUtil.formateStr(410076, curCount, costValue);
			end
			self.costTxt.text = str;
			self.costSp:setEnable(true);
			self.costTxt:setEnable(true);
		end
	end

	self.activeTimeTxt:setEnable(self.bActive);
	self.shareSp:setEnable(self.bActive);

	local bShowBtn = self.bClassic ~= true and self.bActive ~= true;
	self.showBtnSp:setEnable(bShowBtn);
	self.showBtnTxt:setEnable(bShowBtn);


	local bShow = not (self.bClassic ~= true and self.classicId == nil);
	if bShow then
		local spriteSp = self.bClassic and "xui_hb_button_13" or "xui_hb_button_12";
		self.classicCardSp:setAltas("collect_book_atlas", spriteSp);
	end
	self.classicCardSp:setEnable(bShow);

	self:showReward();
	self:updateCardEffect();
	self:showFlashProp();
end

-- 经典卡/神兵卡互换
function Lua_NewCollectionBookCardDetailWindow:onClickClassicCardSp()
	if self.bClassic ~= true and self.classicId == nil then
		OperateAlert.showLangValue(410077);
		return;
	elseif self.bClassic and self.comCardId == nil then
		OperateAlert.showLangValue(410078);
		return;
	end

	self.curCardId = self.bClassic and self.comCardId or self.classicId;
	self.bClassic = not self.bClassic;
	self:updateCardInfo();
end

function Lua_NewCollectionBookCardDetailWindow:showFlashProp()
	local bShow = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.curCardId);
	if bShow then
		local props = self.cardCfg.card_prop or {};
		self.attackDescTxt.text = LanUtil.formateStr(410079, props.attack);
		self.healthDescTxt.text = LanUtil.formateStr(410080, props.health);

	end
	self.flashPropObj:SetActive(bShow);
end

function Lua_NewCollectionBookCardDetailWindow:showReward()
	local bShowReward = self.bookVo.common == self.curCardId and self.bookVo.receive_reward_redpoint;
	self:showRewardItem(bShowReward, self.bookVo.reward);
	self:showRewardRedDot(bShowReward);
end

function Lua_NewCollectionBookCardDetailWindow:showRewardItem(bShow, reward)
	if bShow then
		if self.rewardIcon == nil then
			self.rewardIcon = Lua_ItemIcon.new(self.content);
			self.rewardIcon:setClick(self, self.onClickReward);
			self.rewardIcon:setLocation(234, -338, 0);
			self.rewardIcon:setScale(0.6, 0.6);

			if reward == nil then
				return;
			end

			if reward ~= nil and #reward > 0 then
				local tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]);
				self.rewardIcon:setData(tvo);
			end
		end
		self.rewardIcon:setEnable(true);
	else
		if self.rewardIcon ~= nil then
			self.rewardIcon:setEnable(false);
		end
	end
end

function Lua_NewCollectionBookCardDetailWindow:onClickReward()
	self:hideShareObj();-- 隐藏shareObj
	if self.bookVo.receive_reward_redpoint then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sReceivedReward(self.bagId);
	end
end

function Lua_NewCollectionBookCardDetailWindow:showRewardRedDot(bShow)
	if bShow == true then
		if self.rewardRedPoint == nil then
			self.rewardRedPoint = Lua_RedPointIcon.new(self.content);
			self.rewardRedPoint:setLocation(270, -308, 0);
			self.rewardRedPoint:createRedPointEff();
		end
		self.rewardRedPoint:updateRedPointShow(true);
	else
		if self.rewardRedPoint ~= nil then
			self.rewardRedPoint:updateRedPointShow(false);
		end
	end
end

-- 特效
function Lua_NewCollectionBookCardDetailWindow:updateCardEffect()
	local bShow = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.curCardId);
	if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.frontPageObj, "/effects/uiEffects/ui_scc_sk_0001", "ui_scc_sk_0001", 21, -32);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end

function Lua_NewCollectionBookCardDetailWindow:showBtnRedDot(bShow)
	if bShow == true then
		if self.btnRedPoint == nil then
			self.btnRedPoint = Lua_RedPointIcon.new(self.content);
			self.btnRedPoint:setLocation(94, -320, 0);
			self.btnRedPoint:createRedPointEff();
		end
		self.btnRedPoint:updateRedPointShow(true);
	else
		if self.btnRedPoint ~= nil then
			self.btnRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_NewCollectionBookCardDetailWindow:setFlashCardPos()
	if self.bClassic then
		self.flashItem:setScale(1, 1);
		self.shareSp:setLocation(204, 457);
		-- self.classicCardSp:setLocation(-180, 520);
		self.activeTimeTxt:setLocation(131, 423);
		self.timeBg:setLocation(4, 423);
		self.timeBg:SetDimensions(502, 41);
		LuaUtil.setObjPos(self.shareObj, 142, 350, 0);
	else
		self.flashItem:setScale(0.9, 0.9);
		self.shareSp:setLocation(252, 513);

		-- self.classicCardSp:setLocation(-220, 572);
		self.activeTimeTxt:setLocation(80, 475);
		self.timeBg:setLocation(0, 475);
		self.timeBg:SetDimensions(595, 41);
		LuaUtil.setObjPos(self.shareObj, 193, 403, 0);
	end
	self.flashItem:reSetCurScale();
end

function Lua_NewCollectionBookCardDetailWindow:onShareBgClick()
end

--分享
function Lua_NewCollectionBookCardDetailWindow:onClickShowShareIcon()
	local isShow = self.shareObj.activeSelf;
	self.shareObj:SetActive(not isShow);

	self.isOpenWorld = DataCenter.funcOpenData:isOpened(10228);
	self.worldIcon:setGray(not self.isOpenWorld);
	
	self.isOpenArea = DataCenter.funcOpenData:isOpened(10229);
	local isShow = DataCenter.roleData.league_id > 0 and self.isOpenArea;
	self.areaIcon:setGray(not isShow);
end

function Lua_NewCollectionBookCardDetailWindow:onClickShareWorldIcon()
	if not self.isOpenWorld then
		OperateAlert.showLangValue(410004);
	else
		self.shareObj:SetActive(false);
		local unlockTime = self.bookVo:getCardTimeByCardId(self.curCardId);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD, {cardId = self.curCardId, active_time = unlockTime});
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_NewCollectionBookCardDetailWindow:onClickShareAreaIcon()
	if not self.isOpenArea then
		OperateAlert.showLangValue(410004);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(410058);
	else
		self.shareObj:SetActive(false);
		local unlockTime = self.bookVo:getCardTimeByCardId(self.curCardId);
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD, {cardId = self.curCardId, active_time = unlockTime});
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_NewCollectionBookCardDetailWindow:hideShareObj()
	self.shareObj:SetActive(false);
end

function Lua_NewCollectionBookCardDetailWindow:onClickShowBtnSp()
	self:hideShareObj();-- 隐藏shareObj
	if self.bClassic then
		return;
	end

	if self.bActive then
		return;
	end

	-- 【神兵卡-英雄系统收集】通过英雄系统收集
	local bCollectedFromHeroSystem = self.cardCfg.fromHeroSystem;
	if bCollectedFromHeroSystem then
		local collectionPath = DataCenter.collectionBookUtil:getCollectionHeroPathId();
		DataCenter.packUtil:openPathWindow(collectionPath, false);
	else
		-- 【神兵卡-其他收集方式】	or 【英雄闪卡】
		local bOnlyCard = self.cardCfg.checkOnlyCard;-- 仅有卡
		local bHeroCard = self.cardCfg.checkHeroCard;-- 英雄闪卡
		if bOnlyCard or bHeroCard then
			local canActive = self.bookVo:canActiveByCardId(self.curCardId);
			if canActive then
				Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sActiveCardInfo(self.curCardId);
			else
				local exchangeItems = self.cardCfg.change_item;
				if exchangeItems then
					local itemId = exchangeItems[1][1];
					DataCenter.packUtil:openPathWindow(itemId, false);
				else
					local flashCardCollectiPath = DataCenter.collectionBookUtil:getCollectionFlashPathId();
					DataCenter.packUtil:openPathWindow(flashCardCollectiPath, false);
				end
			end
		else
			--【皮肤闪卡】
			local bSkinCard = self.cardCfg.checkClothCard; -- 皮肤闪卡
			if bSkinCard then
				local collectionPath = DataCenter.collectionBookUtil:getCollectionSkinPathId();
				DataCenter.packUtil:openPathWindow(collectionPath, false);
			end
		end
	end
end

function Lua_NewCollectionBookCardDetailWindow:onPackUpdate(dic)
	if self.cardCfg == nil or self.cardCfg.change_item == nil or #self.cardCfg.change_item <= 0 then
		return;
	end

	local costId;
	local bChange;
	for i = 1, #self.cardCfg.change_item do
		costId = tonumber(self.cardCfg.change_item[i][1]);
		if dic[costId] then
			bChange = true;
			break;
		end
	end

	if not bChange then
		return;
	end
	
	self:updateCardInfo();
end