checkRequire("Lua_NewCollectionBookMainPanel");
checkRequire("Lua_CollectionBookRankPanel");
checkRequire("Lua_NewCollectionBookHeroFetterPlane");
Lua_NewCollectionBookDetailWindow = class("Lua_NewCollectionBookDetailWindow", Lua_Window);
function Lua_NewCollectionBookDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_NewCollectionBookDetailWindow";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_1.jpg";
end

function Lua_NewCollectionBookDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 60, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 1;

	self:createBottomTabList();
end

function Lua_NewCollectionBookDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local toIndex;
	if param ~= nil then
		if type(param) == "table" and param.openIdx ~= nil then
			toIndex = param.openIdx;
		elseif type(param) == "string" or type(param) == "number" then
			toIndex = tonumber(param);
		end
	end

	if toIndex ~= nil then
		self.tabBtnList:setSelected(toIndex);
	end
end


function Lua_NewCollectionBookDetailWindow:dispose()
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabBtnList ~= nil then
		self.tabBtnList:dispose();
		self.tabBtnList = nil;
	end
	if self.panelObj ~= nil then
		for k, v in pairs(self.panelObj) do
			v:dispose();
			v = nil;
		end
		self.panelObj = nil;
	end

	self:superCall("dispose");
end

function Lua_NewCollectionBookDetailWindow:createBottomTabList()
    self.panelObj = {};
	self.tabInfo = Array();
    self.tabInfo:add({ panel = Lua_NewCollectionBookMainPanel,       textAtlas = "collect_book_atlas_2", textNormalSprite = "xui_scc_zgnbutton_4_n", textSelectedSprite = "xui_scc_zgnbutton_4_p", textUnOpenSprite = "xui_scc_zgnbutton_4_d"});
    self.tabInfo:add({ panel = Lua_CollectionBookRankPanel,          textAtlas = "collect_book_atlas_2", textNormalSprite = "xui_scc_zgnbutton_01_n", textSelectedSprite = "xui_scc_zgnbutton_01_p", textUnOpenSprite = "xui_scc_zgnbutton_01_d", redPointId = Lua_RedPointList.CollectionBook_Rank});
    self.tabInfo:add({ panel = Lua_NewCollectionBookHeroFetterPlane, textAtlas = "collect_book_atlas_2", textNormalSprite = "xui_scc_zgnbutton_02_n", textSelectedSprite = "xui_scc_zgnbutton_02_p", textUnOpenSprite = "xui_scc_zgnbutton_02_d", redPointId = Lua_RedPointList.CollectionBook_Fetter});

    self.tabBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.tabBtnList:setRectAnchor(7);
    self.tabBtnList:setLocation(182, 54, 0);
    self.tabBtnList.pivot = -1;
    self.tabBtnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
    self.tabBtnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
    self.tabBtnList:setButtonItem(120, 108);
    self.tabBtnList:setRedPoint(42, 41);
    self.tabBtnList:setClickCallBack(self, self.onTabBtnClick);
    self.tabBtnList:setData(self.tabInfo);
    self.tabBtnList:setEnable(true);
end

function Lua_NewCollectionBookDetailWindow:onTabBtnClick(index)
	if self.selectedIndex == index then
		return;
	end

	self.panel = self.panelObj[self.selectedIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
	end
	
	self.selectedIndex = index;
	self.panel = self.panelObj[index];
	if self.panel == nil then
		local paneName = self.tabInfo[index] ~= nil and self.tabInfo[index].panel ~= nil and self.tabInfo[index].panel or nil;
		if paneName ~= nil then
			self.panel = paneName.new(self.content);
			self.panel:setSiblingIndex(1);
			self.panel:setRectAnchor(9);
			self.panelObj[index] = self.panel;
		else
			return;
		end
	else
		self.panel:setEnable(true);
		if self.panel.onScreenResize then
			self.panel:onScreenResize(self.adaptHeight);
		end
	end

	self:setSharePanel();

	if self.panel.playTween ~= nil then
		self.panel:playTween();
	end
end

function Lua_NewCollectionBookDetailWindow:setSharePanel()
	if self.panel.setSharePanel ~= nil then
		self.panel:setSharePanel(false);
	end
end