checkRequire("Lua_CommonFlashCardItem");
Lua_NewCollectionBookEditWindow = class("Lua_NewCollectionBookEditWindow", Lua_Window);
function Lua_NewCollectionBookEditWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_NewCollectionBookEditWindow";
	self.skinName = "NewCollectionWeaponEditWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_1.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_NewCollectionBookEditWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.hasCardCount = 0;
	self.cardList = Lua_DragList.new(self.content, 636, 262 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.cardList:setListCell(Lua_NewCollectionWeaponEditCardItem, 144, 176, 4);
    self.cardList:setRectAnchor(7);
    self.cardList:setRectPivot(7)
    self.cardList:setLocation( -2, 141, 0);
    self.cardList:setCellSpacing(23, 24);

    self:initSelectedEditPageCardId();
    self.cardListBg:SetDimensions(720, self.adaptHeight + 323);
	self:updateCardList(true);
	self.canelBtnSp:addClickFuntion(self, self.hide);
	self.saveBtnSp:addClickFuntion(self, self.onClickSaveBtn);

	local curCommonCount = DataCenter.collectionBookData.curComCount;
	local curFlashCount = DataCenter.collectionBookData.curFlaCount;
	local totalFlashCardCount = DataCenter.collectionBookUtil.flashTCount;
	local totalOrdinaryCardCount = DataCenter.collectionBookUtil.commonTCount;
	self.collectCountTxt.text = LanUtil.formateStr(410081, 
		curCommonCount, totalOrdinaryCardCount, curFlashCount, totalFlashCardCount);

	self:updateEditPageImg();
	self:updateAdpateNone();
	self:addLuaEvent("NEW_UPDATE_EDITPAGE", self, self.updateEditPageInfo); --更新封面
end

function Lua_NewCollectionBookEditWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.cardList:setContentRect(636, 262 + self.adaptHeight);
	self.cardListBg:SetDimensions(720, self.adaptHeight + 323);

	self:updateAdpateNone();
end

function Lua_NewCollectionBookEditWindow:dispose()
	DataCenter.collectionBookData.selectEditPageCardId = nil;
	self.cardIdArr = nil;
	if self.cardList ~= nil then
		self.cardList:dispose();
		self.cardList = nil;
	end

	self:superCall("dispose");
end

function Lua_NewCollectionBookEditWindow:initSelectedEditPageCardId()
	local cardIds = DataCenter.collectionBookData.ownerPageIds;
	local cardId = cardIds and cardIds[1];

	local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
	if getConfig("collection_bag", bagId) and DataCenter.collectionBookUtil:bShieldCardBag(bagId) ~= true and 
		Lua_CollectionBookConfigData.getConfig(cardId) then
		  self.selectedCardId = cardId;
		  self.originalCardId = cardId;

		  DataCenter.collectionBookData.selectEditPageCardId = cardId;
	end
end

function Lua_NewCollectionBookEditWindow:updateEditPageInfo()
	self:updateEditPageImg();
	self.cardList:setArrayData(self.cardIdArr);
end

function Lua_NewCollectionBookEditWindow:updateEditPageImg()
	local url;
	self.selectedCardId = DataCenter.collectionBookData.selectEditPageCardId;
	local cardCfg = Lua_CollectionBookConfigData.getConfig(self.selectedCardId);
	if cardCfg and cardCfg.page_img then
		url = cardCfg.page_img;
		self.cardNameTxt.text = cardCfg.card_Name;

		local flashId = cardCfg.flash_id;
		local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
		self.cardPageCampSp:setAltas(flashInfo.frontAtlas, flashInfo.frontSprite);
	end
	self.pageImg:setUrl(url);
	self.pageImg:setEnable(url ~= nil);
	self.cardTxtBg:setEnable(url ~= nil);
	self.cardNameTxt:setEnable(url ~= nil);
	self.cardPageCampSp:setEnable(url ~= nil);
end

function Lua_NewCollectionBookEditWindow:updateCardList(isMove)
	self.cardIdArr = DataCenter.collectionBookData:getSortPageEditArr();
	self.hasCardCount = self.cardIdArr:getSize();
	self.cardList:setArrayData(self.cardIdArr);
	self.noneCardSp:setEnable(self.hasCardCount == 0);
	self.noneCardTxt:setEnable(self.hasCardCount == 0);
	if isMove then
		self.cardList:moveToIndex(1, true);
	end
end

function Lua_NewCollectionBookEditWindow:onClickSaveBtn()
	if self.selectedCardId == nil then
		OperateAlert.showLangValue(410082);
		return;
	end

	if self.selectedCardId == self.originalCardId then
		self:hide();
		return;
	end

	self:onSureFun();
end

function Lua_NewCollectionBookEditWindow:onSureFun()
	local carId = self.selectedCardId or 0;
	local list = {carId, 0, 0}
	Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sSaveCBPageInfo(list);
	OperateAlert.showLangValue(410083);
	self:hide();
end

function Lua_NewCollectionBookEditWindow:updateAdpateNone()
	self.noneCardSp:setLocation(-2, 302 + self.adaptHeight / 2);
	self.noneCardTxt:setLocation(1, 260 + self.adaptHeight / 2);
end






































--------------------------------------------------------------------------------------------------------
-- 编辑收藏册卡牌
Lua_NewCollectionWeaponEditCardItem = class("Lua_NewCollectionWeaponEditCardItem", Lua_ListCell);
function Lua_NewCollectionWeaponEditCardItem:ctor(p)
    self:superCall("ctor", p, "NewCollectionWeaponEditCardItem_skin");
end

function Lua_NewCollectionWeaponEditCardItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_NewCollectionWeaponEditCardItem:setData(data)
	self.data = data;
	self.bSelected = nil;
	if self.data == nil then
		return;
	end

	local cfg = Lua_CollectionBookConfigData.getConfig(self.data);
	if cfg == nil then
		return;
	end
	local flashInfo = Lua_FlashCardConfigData.getConfig(cfg.flash_id);
	self.cardIcon:setUrl(flashInfo.flash_path_2);
	self.nameTxt.text = flashInfo.flash_card_name;
	self.bSelected = DataCenter.collectionBookData.selectEditPageCardId == self.data;
	self.isSelectedSp:setEnable(self.bSelected);
end

function Lua_NewCollectionWeaponEditCardItem:onPressClick()
	if self.bSelected then
		DataCenter.collectionBookData.selectEditPageCardId = nil;
	else
		DataCenter.collectionBookData.selectEditPageCardId = self.data;
	end

	Lua_MsgUtil.callFunc("NEW_UPDATE_EDITPAGE");
end

function Lua_NewCollectionWeaponEditCardItem:dispose()
	self:superCall("dispose");
end