checkRequire("Lua_NewCollectionBookPageCardItem");
Lua_NewCollectionBookMainPanel = class("Lua_NewCollectionBookMainPanel", Lua_DisplayObject);
function Lua_NewCollectionBookMainPanel:ctor(p)
	self:superCall("ctor", p, "NewCollectionBookMainPanel_skin");
end

function Lua_NewCollectionBookMainPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showPageCardCount = 4; -- 页面展示卡牌数量
	self.collectCountTxt.text = nil;

	--勾选框
	self.selectedBox:setDir(0);
	self.selectedBox:addBoxChange(self, self.onSelectedBoxChange);

	self.tipsIcon:addClickFuntion(self, self.onClickTipsIcon); -- 提示Icon
	self.lastPageSp:addClickFuntion(self, self.onClickLastPageBtn); -- 上一页
	self.nextPageSp:addClickFuntion(self, self.onClickNextPageBtn); -- 下一页
end

function Lua_NewCollectionBookMainPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_NewCollectionBookMainPanel:setSharePanel(isSharePanel)
	self.isSharePanel = isSharePanel;
	self:createTabBtnList();
	self:setPanelDisplay();
end

function Lua_NewCollectionBookMainPanel:dispose()
	self.cardIds = nil;
	self:hideRedPoint();
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.tabBtnInfo ~= nil then
		self.tabBtnInfo:dispose();
		self.tabBtnInfo:clear();
		self.tabBtnInfo = nil;
	end
	if self.cardItemList ~= nil then
		for i = 1, #self.cardItemList do
			self.cardItemList[i]:dispose();
			self.cardItemList[i] = nil;
		end
		self.cardItemList = nil;
	end
	self:superCall("dispose");
end

function Lua_NewCollectionBookMainPanel:createTabBtnList()
	if self.btnList == nil then
		local hasContactCard = DataCenter.collectionBookUtil.hasContactCard;

		self.tabBtnInfo = Array();
		self.tabBtnInfo:add({ textStr = 410084,   redPointId = self.isSharePanel ~= true and Lua_RedPointList.CollectionBook_WeaponTab or nil});
		self.tabBtnInfo:add({ textStr = 410085,   redPointId = self.isSharePanel ~= true and Lua_RedPointList.CollectionBook_FlashCardTab or nil});
		self.tabBtnInfo:add({ textStr = 410086,     redPointId = nil});
		self.tabBtnInfo:add({ textStr = 410087,     redPointId = self.isSharePanel ~= true and Lua_RedPointList.CollectionBook_FrameCardTab or nil});
		if hasContactCard then
			self.tabBtnInfo:add({ textStr = 410088, redPointId = self.isSharePanel ~= true and Lua_RedPointList.CollectionBook_ContactTab or nil});
		end
		self.tabSp_5:setEnable(hasContactCard);

		self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Vertical);
		self.btnList:setRectPivot(1);
	    self.btnList:setLocation(330, 393, 0)
		self.btnList:setButtonCell(Lua_NewCollectionBookMainTabItem)
		self.btnList:setRedPoint(17, 60)
		self.btnList:setButtonItem(62, 153)
		self.btnList:setClickCallBack(self, self.onBtnClick)
		self.btnList:setSiblingIndex(self.tabSp_5.siblingIndex + 1);
		self.btnList:setData(self.tabBtnInfo)
		self:updateTabRedPoint();
	end
end

function Lua_NewCollectionBookMainPanel:onClickTipsIcon()
	local tipsData = { des = LanUtil.getValue(410027), posX = 194, posY = -216 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_NewCollectionBookMainPanel:setPanelDisplay()
	local curCommonCount;
	local curFlashCount;
	local totalFlashCardCount = DataCenter.collectionBookUtil.flashTCount;
	local totalOrdinaryCardCount = DataCenter.collectionBookUtil.commonTCount;
	if self.isSharePanel then
		local otherPCardInfo = DataCenter.collectionBookData.otherPCardInfo or {};
		curCommonCount = otherPCardInfo.common_amount or 0;
		curFlashCount = otherPCardInfo.flash_amount or 0;

		self.tipsIcon:setEnable(false);
		self.activityNameSp:setEnable(false);
		self.playerNameBg:setEnable(true);
		self.activityNameTxt.text = nil;
		
		local otherPlayerInfo = DataCenter.collectionBookData:getOtherPlayerInfo();
		self.playerNameTxt.text = otherPlayerInfo.name;
	else
		curCommonCount = DataCenter.collectionBookData.curComCount
		curFlashCount = DataCenter.collectionBookData.curFlaCount;

		self.tipsIcon:setEnable(true);
		self.activityNameSp:setEnable(true);
		self.playerNameBg:setEnable(false);
		self.activityNameTxt:setLangValue(410013);
		self.playerNameTxt.text = nil;

		self:addLuaEvent("UPDATE_CBCARDDETAIL_ACTIVECARD", self, self.updateTabRedPoint); -- 卡牌激活更新
		self:addLuaEvent("UPDATE_CBOOKCARD_CanActive", self, self.updateTabRedPoint); -- 卡牌红点数据更新
		self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.updateRewardTab); -- 卡牌奖励更新
		self:addLuaEvent("UPDATE_COLLECTIONBOOK_VIEWFLASHPROP", self, self.updateFlashCardTabRedPoint); -- 闪卡属性查看红点
	end

	self.collectCountTxt.text = LanUtil.formateStr(410081, 
		curCommonCount, totalOrdinaryCardCount, curFlashCount, totalFlashCardCount);

	local selectedIndex, selectedTab = self:checkRedPointCard(); 
	-- local selectedIndex, selectedTab = 1, 1;
	self.firstCardListIndex = selectedIndex; 
	self.btnList:setSelected(selectedTab);
end

function Lua_NewCollectionBookMainPanel:onBtnClick(index)
	if self.selectedTab == index then
		return;
	end

	self:hideTabSp(index);

	self.selectedTab = index;
	if self.cardIndex == nil then
		self.cardIndex = self.firstCardListIndex;
	else
		self.cardIndex = 1;
	end 
	self:updateCardList();
end

function Lua_NewCollectionBookMainPanel:hideTabSp(index)
	local str = "tabSp_";
	if self.selectedTab ~= nil then
		local lastSpStr = str..self.selectedTab;
		self[lastSpStr]:setEnable(true);
	end
	local curSpStr = str..index;
	self[curSpStr]:setEnable(false);
end

function Lua_NewCollectionBookMainPanel:checkRedPointCard()
	if self.isSharePanel then
		return 1, 1;
	end

	local type = 1;
	local selectedIndex = self:getRedPointCardIndexByType(type);
	if selectedIndex ~= nil then
		return selectedIndex, type;
	end

	type = 2;
	selectedIndex = self:getRedPointCardIndexByType(type);
	if selectedIndex ~= nil then
		return selectedIndex, type;
	end

	type = 4;
	selectedIndex = self:getRedPointCardIndexByType(type);
	if selectedIndex ~= nil then
		return selectedIndex, type;
	end

	local hasContactCard = DataCenter.collectionBookUtil.hasContactCard;
	if hasContactCard then
		type = 5;
		selectedIndex = self:getRedPointCardIndexByType(type);
		if selectedIndex ~= nil then
			return selectedIndex, type;
		end
	end

	return 1, 1;
end

function Lua_NewCollectionBookMainPanel:getRedPointCardIndexByType(type)
	local cardIds = self:getCardIds(type, false);
	if cardIds == nil or #cardIds < 1 then
		return nil;
	end

	local vo;
	local bagId;
	local cardId;
	for i = 1, #cardIds do
		cardId = cardIds[i];
		bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		vo = DataCenter.collectionBookData:getCollectionBookVoById(bagId);
		if vo and vo:checkCardItemRedPoint(cardId) then
			local num = Mathf.Floor(i / self.showPageCardCount);
			local residueNum = i % self.showPageCardCount;
			if residueNum == 0 then
				num = num - 1;
			end
			local selectedIndex = num * self.showPageCardCount + 1;
			return selectedIndex;
		end
	end
	return nil;
end

function Lua_NewCollectionBookMainPanel:getCardIds(type, bShare)
	local ids;
	if type == 1 then -- 神兵列传
		if self.bSelected then
			ids = bShare ~= true and DataCenter.collectionBookData.activeWeaponCardIds or DataCenter.collectionBookData.otherActiveWeaponCardIds;
		else
			ids = DataCenter.collectionBookUtil.weaponCardIds;
		end
	elseif type == 2 then -- 炫酷闪卡
		if self.bSelected then
			ids = bShare ~= true and DataCenter.collectionBookData.totalActiveFlashCardIds or DataCenter.collectionBookData.otherTotalActiveFlashCardIds;
		else
			ids = DataCenter.collectionBookUtil.flashCardIds;
		end
	elseif type == 3 then -- 经典卡
		if self.bSelected then
			ids = bShare ~= true and DataCenter.collectionBookData.activeClassicCardIds or DataCenter.collectionBookData.otherActiveClassicCardIds;
		else
			ids = DataCenter.collectionBookUtil.classicCardIds;
		end
	elseif type == 4 then -- 名人堂
		if self.bSelected then
			ids = bShare ~= true and DataCenter.collectionBookData.activeFrameCardIds or DataCenter.collectionBookData.otherActiveFrameCardIds;
		else
			ids = DataCenter.collectionBookUtil.frameCardIds;
		end
	elseif type == 5 then -- 联动卡
		if self.bSelected then
			ids = bShare ~= true and DataCenter.collectionBookData.activeContactCardIds or DataCenter.collectionBookData.otherActiveContactCardIds;
		else
			ids = DataCenter.collectionBookUtil.contactCardIds;
		end
	end

	return ids;
end



function Lua_NewCollectionBookMainPanel:updateCardList()
	self.cardIds = self:getCardIds(self.selectedTab, self.isSharePanel) or {};
	self.cardCount = #self.cardIds;
	self:showNoneCard(self.cardCount == 0);
	self:updateCardItemList();
	self:updatePageNumTxt();
end

function Lua_NewCollectionBookMainPanel:showNoneCard(bShow)
	self.noneCardSp:setEnable(bShow);
	self.noneCardTxt:setEnable(bShow);
end

function Lua_NewCollectionBookMainPanel:updateCardItemList()
	local index;
	local cardId;
	local cardItem;
	for i = 1, self.showPageCardCount do
		index = self.cardIndex + (i - 1);
		cardId = self.cardIds[index];
		cardItem = self:getCardItem(i);
		if cardId ~= nil then
			cardItem:setData(cardId, i, self.isSharePanel, self.selectedTab == 2);
			cardItem:setEnable(true);
		else
			cardItem:setEnable(false);
		end
	end
end

function Lua_NewCollectionBookMainPanel:getCardItem(index)
	if self.cardItemList == nil then
		self.cardItemList = {};
	end

	local item = self.cardItemList[index];
	if item == nil then
		item = Lua_NewCollectionBookPageCardItem.new(self.content);
		self.cardItemList[index] = item;
	end

	return item;
end

function Lua_NewCollectionBookMainPanel:updatePageNumTxt()
	local num = Mathf.Ceil(self.cardIndex / self.showPageCardCount);
	local curPageNum = num == 0 and 1 or num;
	-- print("111num", num, "curPageNum", curPageNum)

	num = Mathf.Ceil(self.cardCount / self.showPageCardCount);
	local totalPageNum = num == 0 and 1 or num;
	-- print("222num", num, "totalPageNum", totalPageNum)
	self.pageNumTxt.text = LanUtil.formateStr(410024, curPageNum, totalPageNum);

	-- print("333self.cardIndex", self.cardIndex, "self.cardCount", self.cardCount)
end

function Lua_NewCollectionBookMainPanel:onSelectedBoxChange(val)
	self.bSelected = self.bSelected == nil and true or not self.bSelected;
	self.cardIndex = 1; 
	self:updateCardList();
end

function Lua_NewCollectionBookMainPanel:onClickLastPageBtn()
	local index = self.cardIndex - self.showPageCardCount;
	if index < 1 then
		OperateAlert.showLangValue(410025);
		return;
	end
	self.cardIndex = index;
	self:updateCardItemList();
	self:updatePageNumTxt();
end

function Lua_NewCollectionBookMainPanel:onClickNextPageBtn()
	local index = self.cardIndex + self.showPageCardCount;
	if index > self.cardCount then
		OperateAlert.showLangValue(410026);
		return;
	end

	self.cardIndex = index;
	self:updateCardItemList();
	self:updatePageNumTxt();
end

function Lua_NewCollectionBookMainPanel:updateTabRedPoint()
	if self.isSharePanel then
		return;
	end

	self:updateWeaponTabRedPoint();
	self:updateFlashCardTabRedPoint();
	self:updateFrameCardTabRedPoint();
	self:updateContactTabRedPoint();
end

function Lua_NewCollectionBookMainPanel:updateRewardTab()
	self:updateWeaponTabRedPoint();
	self:updateFrameCardTabRedPoint();
	self:updateContactTabRedPoint();
end

function Lua_NewCollectionBookMainPanel:updateWeaponTabRedPoint()
	if self.isSharePanel then
		return;
	end

	local bShow = false;
	local selectedIndex = self:getRedPointCardIndexByType(1);
	if selectedIndex ~= nil then
		bShow = true;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_WeaponTab, bShow);
end

function Lua_NewCollectionBookMainPanel:updateFlashCardTabRedPoint()
	if self.isSharePanel then
		return;
	end

	local bShow = false;
	local selectedIndex = self:getRedPointCardIndexByType(2);
	if selectedIndex ~= nil then
		bShow = true;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_FlashCardTab, bShow);
end

function Lua_NewCollectionBookMainPanel:updateFrameCardTabRedPoint()
	if self.isSharePanel then
		return;
	end

	local bShow = false;
	local selectedIndex = self:getRedPointCardIndexByType(4);
	if selectedIndex ~= nil then
		bShow = true;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_FrameCardTab, bShow);
end

function Lua_NewCollectionBookMainPanel:updateContactTabRedPoint()
	if self.isSharePanel then
		return;
	end

	local hasContactCard = DataCenter.collectionBookUtil.hasContactCard;
	if hasContactCard then
		local bShow = false;
		local selectedIndex = self:getRedPointCardIndexByType(5);
		if selectedIndex ~= nil then
			bShow = true;
		end
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_ContactTab, bShow);
	end
end

function Lua_NewCollectionBookMainPanel:hideRedPoint()
	if self.isSharePanel then
		return;
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_WeaponTab, false); -- 收藏册主页-神兵列传
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_FlashCardTab, false);-- 收藏册主页-炫酷闪卡
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_FrameCardTab, false);-- 收藏册主页-名人堂
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CollectionBook_ContactTab, false);-- 收藏册主页-联动卡
end























































Lua_NewCollectionBookMainTabItem = class("Lua_NewCollectionBookMainTabItem", Lua_ButtonCell)
function Lua_NewCollectionBookMainTabItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_NewCollectionBookMainTabItem:buildShowItem()
	self:superCall("buildShowItem")

	self.nameBg = UICreate.createUIAtlasImage(self.content, "collect_book_atlas_2", "xui_scc_tab_02", 0, -92, 62, 184)
	self.nameBg.anchorValue = 1;
	self.nameBg:addClickFuntion(self, self.onPressClick)

	self.nameText = UICreate.createLabel(self.content, nil, -4, 3, 30, 31, 28)
	self.nameText.pivotValue = 4
	self.nameText.alignmentValue = 4;
	self.nameText.horizontalOverflowValue = 0;
	self.nameText.verticalOverflowValue = 1
	self.nameText.fontName = Lua_MyUISettings.huakangFontName
end

function Lua_NewCollectionBookMainTabItem:dispose()
	self:superCall("dispose")
end

function Lua_NewCollectionBookMainTabItem:setData(data)
	self:superCall("setData", data)
	if type(data) == type_str_number then
		self.nameText:setLangValue(data)
	elseif type(data.textStr) == type_str_number then
		self.nameText:setLangValue(data.textStr)
	else
		self.nameText.text = data.textStr
	end
end

function Lua_NewCollectionBookMainTabItem:setSelected(index)
	self:superCall("setSelected", index)
	if index == self.index then -- 选中
		self.nameBg.alpha = 1
		self.nameText.fontSize = 32;
		self.nameText.colorStr = Lua_ColorDefine.transColor("8F5123")
	else
		self.nameBg.alpha = 0.01
		self.nameText.fontSize = 28;
		self.nameText.colorStr = Lua_ColorDefine.transColor("756150")
	end
end