checkRequire("Lua_CommonFlashCardItem");
Lua_NewCollectionBookPageCardItem = class("Lua_NewCollectionBookPageCardItem", Lua_ListCell);
function Lua_NewCollectionBookPageCardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_NewCollectionBookPageCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem.canRotate = false; -- 是否可旋转
	self.flashItem:setSiblingIndex(0);
	self.flashItem:setCallBack(self, self.onPressClick);

	self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.showRewardItem); -- 卡牌奖励更新
	self:addLuaEvent("UPDATE_CBCARDDETAIL_ACTIVECARD", self, self.updateItem); -- 激活卡牌更新
	self:addLuaEvent("UPDATE_COLLECTIONBOOK_VIEWFLASHPROP", self, self.showRedDot); -- 闪卡属性查看红点
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.onPackUpdate); -- 背包道具增加
    self:addLuaEvent("MONEY_UPDATE", self, self.onPackUpdate); -- 货币增加
end

function Lua_NewCollectionBookPageCardItem:dispose()
	self.bookVo = nil;
	self.excharge_item = nil;
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	if self.rewardIcon then
		self.rewardIcon:dispose();
		self.rewardIcon = nil;
	end
	if self.propSp then
		self.propSp:dispose();
		self.propSp = nil;
	end
	self:superCall("dispose");
end

function Lua_NewCollectionBookPageCardItem:updateDisplayByIndex(index, bNewCard)
	local posX, posY, scale;
	if index == 1 then
		posX, posY = -176,  248;
	elseif index == 2 then
		posX, posY =  133,  248;
	elseif index == 3 then
		posX, posY = -176, -171;
	elseif index == 4 then
		posX, posY =  133, -171;
	end
	scale = bNewCard and 0.4 or 0.52;
	self:setLocation( posX, posY);
	self.flashItem:setScale(scale, scale);
end

function Lua_NewCollectionBookPageCardItem:setData(data, index, bShare)
	-- self.data = data;
	-- self.index = index;
	-- self.showId = nil;
	-- self.bShare = bShare;
	-- self.bClassic = bClassic;
	-- self.bCompletionCard = nil;
	-- if self.data == nil then
	-- 	self.excharge_item = nil;
	-- 	return;
	-- end

	-- self:updateItem();

	self.data = data;
	self.index = index;
	self.bShare = bShare;
	self.bCompletionCard = nil;
	self.bookVo = nil;
	if self.data == nil then
		self.excharge_item = nil;
		return;
	end

	self:updateItem();
end

function Lua_NewCollectionBookPageCardItem:updateItem()
	self.excharge_item = nil;
	local cfg = Lua_CollectionBookConfigData.getConfig(self.data);
	if cfg == nil then
		return;
	end

	local flashId = cfg.flash_id;
	local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
	self.flashItem:setData(flashInfo);
	self:updateDisplayByIndex(self.index, flashInfo.showNewCard);

	local bGray;
	local bShowEff;
	self.bCompletionCard = cfg.bCompletion;
	if self.bCompletionCard then
		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(self.data);
		self.bookVo = DataCenter.collectionBookData:getCollectionBookVoById(bagId); 

		if self.bShare then
			bGray = self.bookVo:checkOtherActiveByCardId(self.data) ~= true;
		else
			bGray = self.bookVo:checkActiveByCardId(self.data) ~= true;
			if bGray then
				self.excharge_item = cfg.change_item;
			end
		end
		bShowEff = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);
	else
		self.flashItem:showNocompleteCardState(true);
	end
	self.flashItem:setGray(bGray);
	self:showEffect(bShowEff);
	self:showRewardItem();
	self:showRedDot();
	self:showPropSp();
end

function Lua_NewCollectionBookPageCardItem:showPropSp()
	local bShow = self.bCompletionCard and self.bookVo and self.bShare ~= true;
	bShow = bShow and DataCenter.collectionBookUtil:checkShowEffectByCardId(self.data);
	if bShow then
		if self.propSp == nil then
			self.propSp = UICreate.createUIAtlasImage(self.content, "collect_book_atlas_2", "xui_scc_button_02", 109, 161, 54, 54);
			self.propSp.siblingIndex = 1;
			self.propSp:addClickFuntion(self, self.onClickPropSp);
		end
		self.propSp:setEnable(true);
	else
		if self.propSp ~= nil then
			self.propSp:setEnable(false);
		end
	end
end

function Lua_NewCollectionBookPageCardItem:onClickPropSp()
	Lua_WindowUtil.openWin("Lua_NewCollectionBookFlashCardPropWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_NewCollectionBookPageCardItem:showRedDot()
	local bShow = self.bCompletionCard and self.bShare ~= true;
	if bShow and self.bookVo then
		bShow = self.bookVo:checkCardItemRedPoint(self.data);
	end

	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(127, 181);
			self.redPoint:setSiblingIndex(2);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_NewCollectionBookPageCardItem:showEffect(bShow)
    if bShow then
        if self.effect == nil then
            self.effect = UICreate.createUIEffect(self.flashItem.content, "/effects/uiEffects/ui_scc_sk_0002", "ui_scc_sk_0002", 0, 0);
        end
        self.effect:setEnable(true);
    else
        if self.effect ~= nil then
            self.effect:setEnable(false);
        end
    end
end

function Lua_NewCollectionBookPageCardItem:onPressClick()
	if self.data == nil then
		return;
	end
	
	if not self.bCompletionCard then
		OperateAlert.showLangValue(410033);
		return;
	end

	if self.bShare then
		Lua_WindowUtil.openWin("Lua_NewCollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data));
	else
		Lua_WindowUtil.openWin("Lua_NewCollectionBookCardDetailWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data));
	end
end

function Lua_NewCollectionBookPageCardItem:onPackUpdate(dic)
	if self.excharge_item == nil or #self.excharge_item <= 0 or dic == nil then
		return;
	end

	local costId;
	local bChange;
	for i = 1, #self.excharge_item do
		costId = tonumber(self.excharge_item[i][1]);
		if dic[costId] then
			bChange = true;
			break;
		end
	end

	if not bChange then
		return;
	end

	self:updateItem();
end

function Lua_NewCollectionBookPageCardItem:showRewardItem()
	local reward;
	local bShow = self.bCompletionCard and self.bShare ~= true;
	if bShow and self.bookVo then
		bShow = self.bookVo.common == self.data and self.bookVo.receive_reward_redpoint;
		reward = self.bookVo.reward;
	end

	self:showReward(bShow, reward);
	self:showRedDot();
end

function Lua_NewCollectionBookPageCardItem:showReward(bShow, reward)
	if bShow then
		if self.rewardIcon == nil then
			self.rewardIcon = Lua_ItemIcon.new(self.content);
			self.rewardIcon:setClick(self, self.onClickReward);
			self.rewardIcon:setLocation(93, -150, 0);
			self.rewardIcon:setScale(0.6, 0.6);

			if reward == nil then
				return;
			end

			if reward ~= nil and #reward > 0 then
				local tvo = Lua_ToolVo.createToolVo(reward[1][1], reward[1][2]);
				self.rewardIcon:setData(tvo);
			end
		end
		self.rewardIcon:setEnable(true);
	else
		if self.rewardIcon ~= nil then
			self.rewardIcon:setEnable(false);
		end
	end
end

function Lua_NewCollectionBookPageCardItem:onClickReward()
	if self.bookVo == nil then
		return;
	end

	local enable_receive = self.bookVo.receive_reward_redpoint;
	if enable_receive then
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sReceivedReward(self.bookVo.id);
	end
end