Lua_NewCollectionWeaponBaseWindow = class("Lua_NewCollectionWeaponBaseWindow", Lua_Window);
function Lua_NewCollectionWeaponBaseWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_NewCollectionWeaponBaseWindow";
	self.skinName = "NewCollectionWeaponBaseWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/collect_book/xui_scc_bg_2.jpg";

    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_NewCollectionWeaponBaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.otherPlayerObj:SetActive(false);
	self.selfObj:SetActive(false);
	self.shareObj:SetActive(false);
	self.editSp:setEnable(false);
	self.activityNameTxt:setLangValue(410089);
	self.playerNameTxt.text = nil;
	self.admireCountTxt.text = nil;
	self.collectCountTxt.text = nil;

	self.bottomSp.mouseEnable = true;

	self.totalFlashCardCount = DataCenter.collectionBookUtil.flashTCount;
	self.totalOrdinaryCardCount = DataCenter.collectionBookUtil.commonTCount;
	self:updateWinDisplay();
	
	-- 分享icon的背景
	self.shareBg.clickScale = false;
	self.shareBg.clickSound = nil;
	self.shareBg:addClickFuntion(self, self.onShareBgClick);

	self.editSp:addClickFuntion(self, self.onClickEditSp); -- 编辑封面
	self.tipsIcon:addClickFuntion(self, self.onClickTipsIcon); -- 提示Icon
	self.shareIcon:addClickFuntion(self, self.onClickShowShareIcon); -- 分享显示icon
	self.worldIcon:addClickFuntion(self, self.onClickShareWorldIcon); -- 世界分享icon
	self.areaIcon:addClickFuntion(self, self.onClickShareAreaIcon); -- 频道分享icon
	self.winBg:addClickFuntion(self, self.onClickOpenCardBook); -- 打开卡册
	self.admireSp:addClickFuntion(self, self.onClickAdmireSp); -- 点赞icon
end

function Lua_NewCollectionWeaponBaseWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_NewCollectionWeaponBaseWindow:dispose()
	self:superCall("dispose");
end

function Lua_NewCollectionWeaponBaseWindow:updateWinDisplay()
	self:updateCardCount();-- 卡牌数量更新  
	self:createRedPoint();
	self:updateCollectCountTxt();
	self:updatePageImg();
end

function Lua_NewCollectionWeaponBaseWindow:onShareBgClick()
end

function Lua_NewCollectionWeaponBaseWindow:onClickTipsIcon()
	self:hideShareObj();-- 隐藏shareObj
	local tipsData = { des = LanUtil.getValue(410003), posX = 196, posY = -222 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

--分享
function Lua_NewCollectionWeaponBaseWindow:onClickShowShareIcon()
	local isShow = self.shareObj.activeSelf;
	self.shareObj:SetActive(not isShow);

	self.isOpenWorld = DataCenter.funcOpenData:isOpened(10228);
	self.worldIcon:setGray(not self.isOpenWorld);

	self.isOpenArea = DataCenter.funcOpenData:isOpened(10229);
	local isShow = DataCenter.roleData.league_id > 0 and self.isOpenArea;
	self.areaIcon:setGray(not isShow);
end

function Lua_NewCollectionWeaponBaseWindow:onClickShareWorldIcon()
	if not self.isOpenWorld then
		OperateAlert.showLangValue(410004);
	else
		self:hideShareObj();-- 隐藏shareObj
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_BOOK, true);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_NewCollectionWeaponBaseWindow:onClickShareAreaIcon()
	if not self.isOpenArea then
		OperateAlert.showLangValue(410004);
	elseif DataCenter.roleData.league_id <= 0 then
		OperateAlert.showLangValue(410058);
	else
		self:hideShareObj();-- 隐藏shareObj
		DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_COLLECTION_BOOK, true);
		Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, "", false, false);
		OperateAlert.showLangValue(410071);
	end
end

function Lua_NewCollectionWeaponBaseWindow:hideShareObj()
	self.shareObj:SetActive(false);
end

function Lua_NewCollectionWeaponBaseWindow:onClickOpenCardBook()
end

function Lua_NewCollectionWeaponBaseWindow:onClickAdmireSp()
end

function Lua_NewCollectionWeaponBaseWindow:onClickEditSp()
end

function Lua_NewCollectionWeaponBaseWindow:updateCardCount()
	self.curCommonCount = 0;
	self.curFlashCount = 0;
end

function Lua_NewCollectionWeaponBaseWindow:updateCollectCountTxt()
	self.collectCountTxt.text = LanUtil.formateStr(410081, 
		self.curCommonCount, self.totalOrdinaryCardCount, self.curFlashCount, self.totalFlashCardCount);
end

-- 红点
function Lua_NewCollectionWeaponBaseWindow:createRedPoint()
end

-- 封面
function Lua_NewCollectionWeaponBaseWindow:updatePageImg()
end



