checkRequire("Lua_NewCollectionWeaponBaseWindow");
checkRequire("Lua_CollectionBookTabItem");
Lua_NewCollectionWeaponWindow = class("Lua_NewCollectionWeaponWindow", Lua_NewCollectionWeaponBaseWindow);
function Lua_NewCollectionWeaponWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewCollectionWeaponWindow";
end

function Lua_NewCollectionWeaponWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.otherPlayerObj:SetActive(false);
	self.selfObj:SetActive(true);
	self.editSp:setEnable(true);

	self:addLuaEvent("UPDATE_CBWEAPON_CARDCOUNT", self, self.updateCollectCardInfo); -- 卡牌数量更新
	self:addLuaEvent("UPDATE_CBWEAPON_CARDINFO", self, self.updatePageImg); -- 封面卡牌更新
	self:addLuaEvent("CBWEAPON_HIDESHAREOBJ", self, self.hideShareObj); -- 隐藏shareObj
end

function Lua_NewCollectionWeaponWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_NewCollectionWeaponWindow:dispose()
	if self.redPoint then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.tabList ~= nil then
		self.tabList:dispose();
		self.tabList = nil;
	end

	self:superCall("dispose");
end

function Lua_NewCollectionWeaponWindow:onClickOpenCardBook()
	self:hideShareObj();-- 隐藏shareObj

	Lua_WindowUtil.openWin("Lua_NewCollectionBookDetailWindow", Lua_WinParam.ACTION_OPEN, 1);
end

function Lua_NewCollectionWeaponWindow:updateWinDisplay()
	self:superCall("updateWinDisplay");
	self:createBottomTabList();
end

function Lua_NewCollectionWeaponWindow:updateCardCount()
	self.curCommonCount = DataCenter.collectionBookData.curComCount;
	self.curFlashCount = DataCenter.collectionBookData.curFlaCount;
end

function Lua_NewCollectionWeaponWindow:updateCollectCardInfo()
	self:updateCardCount();
	self:updateCollectCountTxt();
end

-- 红点
function Lua_NewCollectionWeaponWindow:createRedPoint()
	if self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.CollectionBook_MainPage);
		self.redPoint:setLocation(22, 359);
	end
end

function Lua_NewCollectionWeaponWindow:updatePageImg()
	local url;
	local cardIds = DataCenter.collectionBookData.ownerPageIds;
	local cardId = cardIds and cardIds[1];
	if cardId and cardId > 1 then
		local bagId = DataCenter.collectionBookUtil:getCardBagIdByCBId(cardId);
		if getConfig("collection_bag", bagId) and DataCenter.collectionBookUtil:bShieldCardBag(bagId) ~= true then
			local cardCfg = Lua_CollectionBookConfigData.getConfig(cardId);
			if cardCfg and cardCfg.page_img then
				url = cardCfg.page_img;
				self.cardNameTxt.text = cardCfg.card_Name;

				local flashId = cardCfg.flash_id;
				local flashInfo = Lua_FlashCardConfigData.getConfig(flashId);
				self.cardPageCampSp:setAltas(flashInfo.frontAtlas, flashInfo.frontSprite);
			end
		end
	end

	self.pageImg:setUrl(url);
	self.pageImg:setEnable(url ~= nil);
	self.cardTxtBg:setEnable(url ~= nil);
	self.cardNameTxt:setEnable(url ~= nil);
	self.cardPageCampSp:setEnable(url ~= nil);
end

-- 创建底部页签buttonList
function Lua_NewCollectionWeaponWindow:createBottomTabList()
	if not self.isShareWindow then 
	    -- dragList数据
	    self.tabInfo = Array();
	    self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_4_p", openWin = nil, bSelected = true});
	    self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_01_n", openWin = "Lua_NewCollectionBookDetailWindow", tabId = 2, redPointId = Lua_RedPointList.CollectionBook_Rank});
		self.tabInfo:add({ tabAtlas = "collect_book_atlas_2", tabSprite = "xui_scc_zgnbutton_02_n", openWin = "Lua_NewCollectionBookDetailWindow", tabId = 3, redPointId = Lua_RedPointList.CollectionBook_Fetter});  

	    --Lua_DragList
	    local count = self.tabInfo:getSize();
	    local width = count > 4 and 520 or count * 120;
	    self.tabList = Lua_DragList.new(self.content, width, 108, Lua_AxisDefine.Horizontal);
		self.tabList:setLocation(-178, 54, 0);
		self.tabList:setRectAnchor(8);
		self.tabList.pivot = -1;
		self.tabList:setListCell(Lua_CollectionBookTabItem, 120, 108, 1);
		self.tabList:setArrayData(self.tabInfo);
		self.tabList.canDrag = false;
	end
end

function Lua_NewCollectionWeaponWindow:onClickEditSp()
	Lua_WindowUtil.openWin("Lua_NewCollectionBookEditWindow", Lua_WinParam.ACTION_OPEN);
end